//-------------------------------------------------------------------------
/*
Copyright (C) 1996, 2003 - 3D Realms Entertainment
Copyright (C) 2000, 2003 - Matt Saettler (EDuke Enhancements)

This file is part of Enhanced Duke Nukem 3D version 1.5 - Atomic Edition

Duke Nukem 3D is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Original Source: 1996 - Todd Replogle
Prepared for public release: 03/21/2003 - Charlie Wiederhold, 3D Realms

EDuke enhancements integrated: 04/13/2003 - Matt Saettler

Note: EDuke source was in transition.  Changes are in-progress in the
source as it is released.

*/
//-------------------------------------------------------------------------





#include "duke3d.h"
#include "concom.h"
#include "cryptio.h"

#define ERROR_ISAKEYWORD        1
#define ERROR_PARMUNDEFINED     2
#define WARNING_DUPLICATEDEFINITION 3
#define ERROR_COULDNOTFIND 4
#define ERROR_VARREADONLY 5
#define ERROR_NOTAGAMEDEF 6
#define ERROR_SYMBOLNOTRECOGNIZED 7
#define ERROR_EXPECTINGKEYWORD 8
#define ERROR_NOTAGAMEVAR 9
#define ERROR_OPENBRACKET 10
#define ERROR_CLOSEBRACKET 11
#define ERROR_NOENDSWITCH 12


// char achErrorKeyword[]="  * ERROR!(L%ld) Symbol '%s' is a key word.\n";
void ReportError(int iError);

#ifdef WW2

long *casescriptptr=NULL;       // the pointer to the start of the case table in a switch statement
// first entry is 'default' code.
char casecount=0;

long *parsing_event=NULL;

char g_achSourceFiles[MAXSOURCEFILES][100];
void AddSourceFile(char *ach);
void PopSourceFile();
int g_numSourceFiles=0;
int g_currentSourceFile=0;

#endif


short total_lines;
char checking_ifelse,parsing_state,*last_used_text;
#ifdef EDUKE
short checking_switch=0;
short localplayeronly=0;        // should local player only commands be allowed?
#endif
short num_squigilly_brackets;
long last_used_size;

char *keyw[NUMKEYWORDS] =
{
        "definelevelname",      // 0
        "actor",                        // 1    [#]
        "addammo",       // 2    [#]
        "ifrnd",                        // 3    [C]
        "enda",                         // 4    [:]
        "ifcansee",                     // 5    [C]
        "ifhitweapon",          // 6    [#]
        "action",                       // 7    [#]
        "ifpdistl",                     // 8    [#]
        "ifpdistg",                     // 9    [#]
        "else",                         // 10   [#]
        "strength",                     // 11   [#]
        "break",                        // 12   [#]
        "shoot",                        // 13   [#]
        "palfrom",                      // 14   [#]
        "sound",                        // 15   [filename.voc]
        "fall",                         // 16   []
        "state",                        // 17
        "ends",                         // 18
        "define",                       // 19
        "//",                           // 20
        "ifai",                         // 21
        "killit",                       // 22
        "addweapon",            // 23
        "ai",                           // 24
        "addphealth",           // 25
        "ifdead",                       // 26
        "ifsquished",           // 27
        "sizeto",                       // 28
        "{",                            // 29
        "}",                            // 30
        "spawn",                        // 31
        "move",                         // 32
        "ifwasweapon",          // 33
        "ifaction",                     // 34
        "ifactioncount",        // 35
        "resetactioncount", // 36
        "debris",                       // 37
        "pstomp",                       // 38
        "/*",                           // 39
        "cstat",                        // 40
        "ifmove",                       // 41
        "resetplayer",          // 42
        "ifonwater",            // 43
        "ifinwater",            // 44
        "ifcanshoottarget", // 45
        "ifcount",                      // 46
        "resetcount",           // 47
        "addinventory",         // 48
        "ifactornotstayput",// 49
        "hitradius",            // 50
        "ifp",                          // 51
        "count",                        // 52
        "ifactor",                      // 53
        "music",                        // 54
        "include",                      // 55
        "ifstrength",           // 56
        "definesound",          // 57
        "guts",                         // 58
        "ifspawnedby",          // 59
        "gamestartup",          // 60
        "wackplayer",           // 61
        "ifgapzl",                      // 62
        "ifhitspace",           // 63
        "ifoutside",            // 64
        "ifmultiplayer",        // 65
        "operate",                      // 66
        "ifinspace",            // 67
        "debug",                        // 68
        "endofgame",            // 69
        "ifbulletnear",         // 70
        "ifrespawn",            // 71
        "iffloordistl",         // 72
        "ifceilingdistl",       // 73
        "spritepal",            // 74
        "ifpinventory",         // 75
        "betaname",                     // 76
        "cactor",                       // 77
        "ifphealthl",           // 78
        "definequote",          // 79
        "quote",                        // 80
        "ifinouterspace",       // 81
        "ifnotmoving",          // 82
        "respawnhitag",            // 83
        "tip",                     // 84
        "ifspritepal",          // 85
        "money",                 // 86
        "soundonce",             // 87
        "addkills",                     // 88
        "stopsound",            // 89
        "ifawayfromwall",               // 90
        "ifcanseetarget",       // 91
        "globalsound",  // 92
        "lotsofglass", // 93
        "ifgotweaponce", // 94
        "getlastpal", // 95
        "pkick",  // 96
        "mikesnd", // 97
        "useractor",  // 98
        "sizeat",  // 99
        "addstrength", // 100   [#]
        "cstator", // 101
        "mail", // 102
        "paper", // 103
        "tossweapon", // 104
        "sleeptime", // 105
        "nullop", // 106
        "definevolumename", // 107
        "defineskillname", // 108
        "ifnosounds", // 109
        "clipdist", // 110
        "ifangdiffl" // 111
#ifdef WW2
        ,"gamevar"      // 112
                        
        ,"ifvarl"       // 113
                        
        ,"ifvarg"       // 114

        ,"setvarvar"    // 115
                        
        ,"setvar"       // 116
                        
        ,"addvarvar"    // 117
                        
        ,"addvar"       // 118
                        
        ,"ifvarvarl"    // 119

        ,"ifvarvarg"    // 120

        ,"addlogvar"    // 121
                        
        ,"addlog"       // 122

        ,"onevent"      // 123

        ,"endevent"     // 124

        ,"ifvare"       // 125

        ,"ifvarvare"    // 126
#ifdef EDUKE                    
        ,"spgetlotag"           // 127
                        
        ,"spgethitag"           // 128
                        
        ,"sectgetlotag"         // 129
                        
        ,"sectgethitag"         // 130
                        
        ,"ifsound"              // 131
        ,"gettexturefloor"              // 132
        ,"gettextureceiling"            // 133
        ,"gettexturewall"               // 134
        ,"starttrack"           // 135
        ,"randvar"              // 136
        ,"enhanced"             // 137
        ,"getangletotarget"             // 138
        ,"getactorangle"                // 139
        ,"setactorangle"                // 140
        ,"mulvar"               // 141
        ,"mulvarvar"            // 142
        ,"divvar"               // 143
        ,"divvarvar"            // 144
        ,"modvar"               // 145
        ,"modvarvar"            // 146
        ,"andvar"               // 147
        ,"andvarvar"            // 148
        ,"orvar"                // 149
        ,"orvarvar"             // 150
        ,"getplayerangle"               // 151
        ,"setplayerangle"               // 152
        ,"lockplayer"           // 153
        ,"setsector"            // 154
        ,"getsector"            // 155
        ,"setactor"             // 156
        ,"getactor"             // 157
        ,"setwall"              // 158
        ,"getwall"              // 159
        ,"findnearactor"                // 160
        ,"findnearactorvar"             // 161
        ,"setactorvar"          // 162
        ,"getactorvar"          // 163
        ,"espawn"               // 164
        ,"getplayer"            // 165
        ,"setplayer"            // 166
        ,"sqrt"         // 167
        ,"eventloadactor"               // 168
        ,"espawnvar"            // 169
        ,"getuserdef"           // 170
        ,"setuserdef"           // 171
        ,"subvarvar"    // 172
        ,"subvar"       // 173
        ,"ifvarn"       // 174
        ,"ifvarvarn"    // 175
        ,"ifvarand"     // 176
        ,"ifvarvarand"  // 177
        ,"myos" // 178
        ,"myospal"      // 179
        ,"switch"       // 180
        ,"case" // 181
        ,"default"      // 182
        ,"endswitch"    // 183
        ,"displayrand"  // 184
        ,"sin"  // 185
        ,"xorvarvar"    // 186
        ,"xorvar"       // 187
        ,"randvarvar"   // 188
        ,"myosx" // 189
        ,"myospalx" //190
        ,"gmaxammo" // 191
        ,"smaxammo" // 192
        ,"mapvoxel" // 193
        ,"startlevel" //194
                        
#endif
// TODO: add playanm <id> <id2> (called on OnAction(NEWGAME) )
#endif
};

#ifdef WW2

typedef struct _labels
{
        char *name;
        long lId;
        int     flags;
#define LABEL_HASPARM2  1
#define LABEL_ISSTRING  2
        int maxParm2;
} LABELS;

LABELS sectorlabels[]=
 {
  {     "wallptr", SECTOR_WALLPTR, 0, 0 },
  { "wallnum", SECTOR_WALLNUM, 0, 0 },
  { "ceilingz", SECTOR_CEILINGZ, 0, 0 },
  { "floorz", SECTOR_FLOORZ, 0, 0 },
  { "ceilingstat", SECTOR_CEILINGSTAT, 0, 0 },
  { "floorstat", SECTOR_FLOORSTAT, 0, 0 },
  { "ceilingpicnum", SECTOR_CEILINGPICNUM, 0, 0 },
  { "ceilingslope", SECTOR_CEILINGSLOPE, 0, 0 },
  { "ceilingshade", SECTOR_CEILINGSHADE, 0, 0 },
  { "ceilingpal", SECTOR_CEILINGPAL, 0, 0 },
  { "ceilingxpanning", SECTOR_CEILINGXPANNING, 0, 0 },
  { "ceilingypanning", SECTOR_CEILINGYPANNING, 0, 0 },
  { "floorpicnum", SECTOR_FLOORPICNUM, 0, 0 },
  { "floorslope", SECTOR_FLOORSLOPE, 0, 0 },
  { "floorshade", SECTOR_FLOORSHADE, 0, 0 },
  { "floorpal", SECTOR_FLOORPAL, 0, 0 },
  { "floorxpanning", SECTOR_FLOORXPANNING, 0, 0 },
  { "floorypanning", SECTOR_FLOORYPANNING, 0, 0 },
  { "visibility", SECTOR_VISIBILITY, 0, 0 },
  { "alignto", SECTOR_ALIGNTO, 0, 0 },
  { "lotag", SECTOR_LOTAG, 0, 0 },
  { "hitag", SECTOR_HITAG, 0, 0 },
  { "extra", SECTOR_EXTRA, 0, 0 },

  { "", -1, 0, 0  }     // END OF LIST
 };

LABELS walllabels[]=
{
        { "x", WALL_X, 0, 0 },
        { "y", WALL_Y, 0, 0 },
        { "point2", WALL_POINT2, 0, 0 },
        { "nextwall", WALL_NEXTWALL, 0, 0 },
        { "nextsector", WALL_NEXTSECTOR, 0, 0 },
        { "cstat", WALL_CSTAT, 0, 0 },
        { "picnum", WALL_PICNUM, 0, 0 },
        { "overpicnum", WALL_OVERPICNUM, 0, 0 },
        { "shade", WALL_SHADE, 0, 0 },
        { "pal", WALL_PAL, 0, 0 },
        { "xrepeat", WALL_XREPEAT, 0, 0 },
        { "yrepeat", WALL_YREPEAT, 0, 0 },
        { "xpanning", WALL_XPANNING, 0, 0 },
        { "ypanning", WALL_YPANNING, 0, 0 },
        { "lotag", WALL_LOTAG, 0, 0 },
        { "hitag", WALL_HITAG, 0, 0 },
        { "extra", WALL_EXTRA, 0, 0 },
        
  { "", -1, 0, 0  }     // END OF LIST

};

LABELS actorlabels[]=
{
        { "x", ACTOR_X, 0, 0 },
        { "y", ACTOR_Y, 0, 0 },
        { "z", ACTOR_Z, 0, 0 },
        { "cstat", ACTOR_CSTAT, 0, 0 },
        { "picnum", ACTOR_PICNUM, 0, 0 },
        { "shade", ACTOR_SHADE, 0, 0 },
        { "pal", ACTOR_PAL, 0, 0 },
        { "clipdist", ACTOR_CLIPDIST, 0, 0 },
        { "detail", ACTOR_DETAIL, 0, 0 },
        { "xrepeat", ACTOR_XREPEAT, 0, 0 },
        { "yrepeat", ACTOR_YREPEAT, 0, 0 },
        { "xoffset", ACTOR_XOFFSET, 0, 0 },
        { "yoffset", ACTOR_YOFFSET, 0, 0 },
        { "sectnum", ACTOR_SECTNUM, 0, 0 },
        { "statnum", ACTOR_STATNUM, 0, 0 },
        { "ang", ACTOR_ANG, 0, 0 },
        { "owner", ACTOR_OWNER, 0, 0 },
        { "xvel", ACTOR_XVEL, 0, 0 },
        { "yvel", ACTOR_YVEL, 0, 0 },
        { "zvel", ACTOR_ZVEL, 0, 0 },
        { "lotag", ACTOR_LOTAG, 0, 0 },
        { "hitag", ACTOR_HITAG, 0, 0 },
        { "extra", ACTOR_EXTRA, 0, 0 },

        // hittype labels...
        { "htcgg", ACTOR_HTCGG, 0, 0 },
        { "htpicnum", ACTOR_HTPICNUM, 0, 0 },
        { "htang", ACTOR_HTANG, 0, 0 },
        { "htextra", ACTOR_HTEXTRA, 0, 0 },
        { "htowner", ACTOR_HTOWNER, 0, 0 },
        { "htmovflag", ACTOR_HTMOVFLAG, 0, 0 },
        { "httempang", ACTOR_HTTEMPANG, 0, 0 },
        { "htactorstayput", ACTOR_HTACTORSTAYPUT, 0, 0 },
        { "htdispicnum", ACTOR_HTDISPICNUM, 0, 0 },
        { "httimetosleep", ACTOR_HTTIMETOSLEEP, 0, 0 },
        { "htfloorz", ACTOR_HTFLOORZ, 0, 0 },
        { "htceilingz", ACTOR_HTCEILINGZ, 0, 0 },
        { "htlastvx", ACTOR_HTLASTVX, 0, 0 },
        { "htlastvy", ACTOR_HTLASTVY, 0, 0 },
        { "htbposx", ACTOR_HTBPOSX, 0, 0 },
        { "htbposy", ACTOR_HTBPOSY, 0, 0 },
        { "htbposz", ACTOR_HTBPOSZ, 0, 0 },
        { "htg_t", ACTOR_HTG_T, LABEL_HASPARM2, 5 },
        { "htg_t[0]", ACTOR_HTG_T0, 0, 0 },
        { "htg_t[1]", ACTOR_HTG_T1, 0, 0 },
        { "htg_t[2]", ACTOR_HTG_T2, 0, 0 },
        { "htg_t[3]", ACTOR_HTG_T3, 0, 0 },
        { "htg_t[4]", ACTOR_HTG_T4, 0, 0 },
        { "htg_t[5]", ACTOR_HTG_T5, 0, 0 },

  { "", -1, 0, 0  }     // END OF LIST
        
};


//////////////////////////////////

LABELS playerlabels[]=
{
        { "zoom", PLAYER_ZOOM, 0, 0 },
        { "exitx", PLAYER_EXITX, 0, 0 },
        { "exity", PLAYER_EXITY, 0, 0 },
        { "loogiex", PLAYER_LOOGIEX, LABEL_HASPARM2, 64 },
        { "loogiey", PLAYER_LOOGIEY, LABEL_HASPARM2, 64 },
        { "numloogs", PLAYER_NUMLOOGS, 0, 0 },
        { "loogcnt", PLAYER_LOOGCNT, 0, 0 },
        { "posx", PLAYER_POSX, 0, 0 },
        { "posy", PLAYER_POSY, 0, 0 },
        { "posz", PLAYER_POSZ, 0, 0 },
        { "horiz", PLAYER_HORIZ, 0, 0 },
        { "ohoriz", PLAYER_OHORIZ, 0, 0 },
        { "ohorizoff", PLAYER_OHORIZOFF, 0, 0 },
        { "invdisptime", PLAYER_INVDISPTIME, 0, 0 },
        { "bobposx", PLAYER_BOBPOSX, 0, 0 },
        { "bobposy", PLAYER_BOBPOSY, 0, 0 },
        { "oposx", PLAYER_OPOSX, 0, 0 },
        { "oposy", PLAYER_OPOSY, 0, 0 },
        { "oposz", PLAYER_OPOSZ, 0, 0 },
        { "pyoff", PLAYER_PYOFF, 0, 0 },
        { "opyoff", PLAYER_OPYOFF, 0, 0 },
        { "posxv", PLAYER_POSXV, 0, 0 },
        { "posyv", PLAYER_POSYV, 0, 0 },
        { "poszv", PLAYER_POSZV, 0, 0 },
        { "last_pissed_time", PLAYER_LAST_PISSED_TIME, 0, 0 },
        { "truefz", PLAYER_TRUEFZ, 0, 0 },
        { "truecz", PLAYER_TRUECZ, 0, 0 },
        { "player_par", PLAYER_PLAYER_PAR, 0, 0 },
        { "visibility", PLAYER_VISIBILITY, 0, 0 },
        { "bobcounter", PLAYER_BOBCOUNTER, 0, 0 },
        { "weapon_sway", PLAYER_WEAPON_SWAY, 0, 0 },
        { "pals_time", PLAYER_PALS_TIME, 0, 0 },
        { "randomflamex", PLAYER_RANDOMFLAMEX, 0, 0 },
        { "crack_time", PLAYER_CRACK_TIME, 0, 0 },
        { "aim_mode", PLAYER_AIM_MODE, 0, 0 },
        { "ang", PLAYER_ANG, 0, 0 },
        { "oang", PLAYER_OANG, 0, 0 },
        { "angvel", PLAYER_ANGVEL, 0, 0 },
        { "cursectnum", PLAYER_CURSECTNUM, 0, 0 },
        { "look_ang", PLAYER_LOOK_ANG, 0, 0 },
        { "last_extra", PLAYER_LAST_EXTRA, 0, 0 },
        { "subweapon", PLAYER_SUBWEAPON, 0, 0 },
        { "ammo_amount", PLAYER_AMMO_AMOUNT, LABEL_HASPARM2, MAX_WEAPONS },
        { "wackedbyactor", PLAYER_WACKEDBYACTOR, 0, 0 },
        { "frag", PLAYER_FRAG, 0, 0 },
        { "fraggedself", PLAYER_FRAGGEDSELF, 0, 0 },
        { "curr_weapon", PLAYER_CURR_WEAPON, 0, 0 },
        { "last_weapon", PLAYER_LAST_WEAPON, 0, 0 },
        { "tipincs", PLAYER_TIPINCS, 0, 0 },
        { "horizoff", PLAYER_HORIZOFF, 0, 0 },
        { "wantweaponfire", PLAYER_WANTWEAPONFIRE, 0, 0 },
        { "holoduke_amount", PLAYER_HOLODUKE_AMOUNT, 0, 0 },
        { "newowner", PLAYER_NEWOWNER, 0, 0 },
        { "hurt_delay", PLAYER_HURT_DELAY, 0, 0 },
        { "hbomb_hold_delay", PLAYER_HBOMB_HOLD_DELAY, 0, 0 },
        { "jumping_counter", PLAYER_JUMPING_COUNTER, 0, 0 },
        { "airleft", PLAYER_AIRLEFT, 0, 0 },
        { "knee_incs", PLAYER_KNEE_INCS, 0, 0 },
        { "access_incs", PLAYER_ACCESS_INCS, 0, 0 },
        { "fta", PLAYER_FTA, 0, 0 },
        { "ftq", PLAYER_FTQ, 0, 0 },
        { "access_wallnum", PLAYER_ACCESS_WALLNUM, 0, 0 },
        { "access_spritenum", PLAYER_ACCESS_SPRITENUM, 0, 0 },
        { "kickback_pic", PLAYER_KICKBACK_PIC, 0, 0 },
        { "got_access", PLAYER_GOT_ACCESS, 0, 0 },
        { "weapon_ang", PLAYER_WEAPON_ANG, 0, 0 },
        { "firstaid_amount", PLAYER_FIRSTAID_AMOUNT, 0, 0 },
        { "somethingonplayer", PLAYER_SOMETHINGONPLAYER, 0, 0 },
        { "on_crane", PLAYER_ON_CRANE, 0, 0 },
        { "i", PLAYER_I, 0, 0 },
        { "one_parallax_sectnum", PLAYER_ONE_PARALLAX_SECTNUM, 0, 0 },
        { "over_shoulder_on", PLAYER_OVER_SHOULDER_ON, 0, 0 },
        { "random_club_frame", PLAYER_RANDOM_CLUB_FRAME, 0, 0 },
        { "fist_incs", PLAYER_FIST_INCS, 0, 0 },
        { "one_eighty_count", PLAYER_ONE_EIGHTY_COUNT, 0, 0 },
        { "cheat_phase", PLAYER_CHEAT_PHASE, 0, 0 },
        { "dummyplayersprite", PLAYER_DUMMYPLAYERSPRITE, 0, 0 },
        { "extra_extra8", PLAYER_EXTRA_EXTRA8, 0, 0 },
        { "quick_kick", PLAYER_QUICK_KICK, 0, 0 },
        { "heat_amount", PLAYER_HEAT_AMOUNT, 0, 0 },
        { "actorsqu", PLAYER_ACTORSQU, 0, 0 },
        { "timebeforeexit", PLAYER_TIMEBEFOREEXIT, 0, 0 },
        { "customexitsound", PLAYER_CUSTOMEXITSOUND, 0, 0 },
        { "weaprecs[16]", PLAYER_WEAPRECS, 0, 0 },
        { "weapreccnt", PLAYER_WEAPRECCNT, 0, 0 },
        { "interface_toggle_flag", PLAYER_INTERFACE_TOGGLE_FLAG, 0, 0 },
        { "rotscrnang", PLAYER_ROTSCRNANG, 0, 0 },
        { "dead_flag", PLAYER_DEAD_FLAG, 0, 0 },
        { "show_empty_weapon", PLAYER_SHOW_EMPTY_WEAPON, 0, 0 },
        { "scuba_amount", PLAYER_SCUBA_AMOUNT, 0, 0 },
        { "jetpack_amount", PLAYER_JETPACK_AMOUNT, 0, 0 },
        { "steroids_amount", PLAYER_STEROIDS_AMOUNT, 0, 0 },
        { "shield_amount", PLAYER_SHIELD_AMOUNT, 0, 0 },
        { "holoduke_on", PLAYER_HOLODUKE_ON, 0, 0 },
        { "pycount", PLAYER_PYCOUNT, 0, 0 },
        { "weapon_pos", PLAYER_WEAPON_POS, 0, 0 },
        { "frag_ps", PLAYER_FRAG_PS, 0, 0 },
        { "transporter_hold", PLAYER_TRANSPORTER_HOLD, 0, 0 },
        { "last_full_weapon", PLAYER_LAST_FULL_WEAPON, 0, 0 },
        { "footprintshade", PLAYER_FOOTPRINTSHADE, 0, 0 },
        { "boot_amount", PLAYER_BOOT_AMOUNT, 0, 0 },
        { "scream_voice", PLAYER_SCREAM_VOICE, 0, 0 },
        { "gm", PLAYER_GM, 0, 0 },
        { "on_warping_sector", PLAYER_ON_WARPING_SECTOR, 0, 0 },
        { "footprintcount", PLAYER_FOOTPRINTCOUNT, 0, 0 },
        { "hbomb_on", PLAYER_HBOMB_ON, 0, 0 },
        { "jumping_toggle", PLAYER_JUMPING_TOGGLE, 0, 0 },
        { "rapid_fire_hold", PLAYER_RAPID_FIRE_HOLD, 0, 0 },
        { "on_ground", PLAYER_ON_GROUND, 0, 0 },
        { "name", PLAYER_NAME,  LABEL_ISSTRING, 32 },
        { "inven_icon", PLAYER_INVEN_ICON, 0, 0 },
        { "buttonpalette", PLAYER_BUTTONPALETTE, 0, 0 },
        { "jetpack_on", PLAYER_JETPACK_ON, 0, 0 },
        { "spritebridge", PLAYER_SPRITEBRIDGE, 0, 0 },
        { "lastrandomspot", PLAYER_LASTRANDOMSPOT, 0, 0 },
        { "scuba_on", PLAYER_SCUBA_ON, 0, 0 },
        { "footprintpal", PLAYER_FOOTPRINTPAL, 0, 0 },
        { "heat_on", PLAYER_HEAT_ON, 0, 0 },
        { "holster_weapon", PLAYER_HOLSTER_WEAPON, 0, 0 },
        { "falling_counter", PLAYER_FALLING_COUNTER, 0, 0 },
        { "gotweapon[MAX_WEAPONS]", PLAYER_GOTWEAPON, 0, 0 },
        { "refresh_inventory", PLAYER_REFRESH_INVENTORY, 0, 0 },
        { "palette", PLAYER_PALETTE, 0, 0 },
        { "toggle_key_flag", PLAYER_TOGGLE_KEY_FLAG, 0, 0 },
        { "knuckle_incs", PLAYER_KNUCKLE_INCS, 0, 0 },
        { "walking_snd_toggle", PLAYER_WALKING_SND_TOGGLE, 0, 0 },
        { "palookup", PLAYER_PALOOKUP, 0, 0 },
        { "hard_landing", PLAYER_HARD_LANDING, 0, 0 },
        { "max_secret_rooms", PLAYER_MAX_SECRET_ROOMS, 0, 0 },
        { "secret_rooms", PLAYER_SECRET_ROOMS, 0, 0 },
        { "pals", PLAYER_PALS, LABEL_HASPARM2, 3 },
        { "max_actors_killed", PLAYER_MAX_ACTORS_KILLED, 0, 0 },
        { "actors_killed", PLAYER_ACTORS_KILLED, 0, 0 },
        { "return_to_center", PLAYER_RETURN_TO_CENTER, 0, 0 },
        
  { "", -1, 0, 0  }     // END OF LIST
        
};

///////////////////////////////////////

LABELS userdefslabels[]=
{
        { "god", USERDEFS_GOD, 0, 0 },
        { "warp_on", USERDEFS_WARP_ON, 0, 0 },
        { "cashman", USERDEFS_CASHMAN, 0, 0 },
        { "eog", USERDEFS_EOG, 0, 0 },
        { "showallmap", USERDEFS_SHOWALLMAP, 0, 0 },
        { "show_help", USERDEFS_SHOW_HELP, 0, 0 },
        { "scrollmode", USERDEFS_SCROLLMODE, 0, 0 },
        { "clipping", USERDEFS_CLIPPING, 0, 0 },
        { "user_name", USERDEFS_USER_NAME, LABEL_HASPARM2, MAXPLAYERS },
        { "ridecule", USERDEFS_RIDECULE, LABEL_HASPARM2 | LABEL_ISSTRING, 10 },
        { "savegame", USERDEFS_SAVEGAME, LABEL_HASPARM2 | LABEL_ISSTRING, 10 },
        { "pwlockout", USERDEFS_PWLOCKOUT, LABEL_ISSTRING, 128 },
        { "rtsname;", USERDEFS_RTSNAME,  LABEL_ISSTRING, 128 },
 { "overhead_on", USERDEFS_OVERHEAD_ON, 0, 0 },
 { "last_overhead", USERDEFS_LAST_OVERHEAD, 0, 0 },
 { "showweapons", USERDEFS_SHOWWEAPONS, 0, 0 },

 { "pause_on", USERDEFS_PAUSE_ON, 0, 0 },
 { "from_bonus", USERDEFS_FROM_BONUS, 0, 0 },
 { "camerasprite", USERDEFS_CAMERASPRITE, 0, 0 },
 { "last_camsprite", USERDEFS_LAST_CAMSPRITE, 0, 0 },
 { "last_level", USERDEFS_LAST_LEVEL, 0, 0 },
 { "secretlevel", USERDEFS_SECRETLEVEL, 0, 0 },

 { "const_visibility", USERDEFS_CONST_VISIBILITY, 0, 0 },
 { "uw_framerate", USERDEFS_UW_FRAMERATE, 0, 0 },
 { "camera_time", USERDEFS_CAMERA_TIME, 0, 0 },
 { "folfvel", USERDEFS_FOLFVEL, 0, 0 },
 { "folavel", USERDEFS_FOLAVEL, 0, 0 },
 { "folx", USERDEFS_FOLX, 0, 0 },
 { "foly", USERDEFS_FOLY, 0, 0 },
 { "fola", USERDEFS_FOLA, 0, 0 },
 { "reccnt", USERDEFS_RECCNT, 0, 0 },

 { "entered_name", USERDEFS_ENTERED_NAME, 0, 0 },
 { "screen_tilting", USERDEFS_SCREEN_TILTING, 0, 0 },
 { "shadows", USERDEFS_SHADOWS, 0, 0 },
 { "fta_on", USERDEFS_FTA_ON, 0, 0 },
 { "executions", USERDEFS_EXECUTIONS, 0, 0 },
 { "auto_run", USERDEFS_AUTO_RUN, 0, 0 },
 { "coords", USERDEFS_COORDS, 0, 0 },
 { "tickrate", USERDEFS_TICKRATE, 0, 0 },
 { "m_coop", USERDEFS_M_COOP, 0, 0 },
 { "coop", USERDEFS_COOP, 0, 0 },
 { "screen_size", USERDEFS_SCREEN_SIZE, 0, 0 },
 { "lockout", USERDEFS_LOCKOUT, 0, 0 },
 { "crosshair", USERDEFS_CROSSHAIR, 0, 0 },
 { "wchoice[MAXPLAYERS][MAX_WEAPONS]", USERDEFS_WCHOICE, 0, 0 },
 { "playerai", USERDEFS_PLAYERAI, 0, 0 },
 { "respawn_monsters", USERDEFS_RESPAWN_MONSTERS, 0, 0 },
 { "respawn_items", USERDEFS_RESPAWN_ITEMS, 0, 0 },
 { "respawn_inventory", USERDEFS_RESPAWN_INVENTORY, 0, 0 },
 { "recstat", USERDEFS_RECSTAT, 0, 0 },
 { "monsters_off", USERDEFS_MONSTERS_OFF, 0, 0 },
 { "brightness", USERDEFS_BRIGHTNESS, 0, 0 },
 { "m_respawn_items", USERDEFS_M_RESPAWN_ITEMS, 0, 0 },
 { "m_respawn_monsters", USERDEFS_M_RESPAWN_MONSTERS, 0, 0 },
 { "m_respawn_inventory", USERDEFS_M_RESPAWN_INVENTORY, 0, 0 },
 { "m_recstat", USERDEFS_M_RECSTAT, 0, 0 },
 { "m_monsters_off", USERDEFS_M_MONSTERS_OFF, 0, 0 },
 { "detail", USERDEFS_DETAIL, 0, 0 },
 { "m_ffire", USERDEFS_M_FFIRE, 0, 0 },
 { "ffire", USERDEFS_FFIRE, 0, 0 },
 { "m_player_skill", USERDEFS_M_PLAYER_SKILL, 0, 0 },
 { "m_level_number", USERDEFS_M_LEVEL_NUMBER, 0, 0 },
 { "m_volume_number", USERDEFS_M_VOLUME_NUMBER, 0, 0 },
 { "multimode", USERDEFS_MULTIMODE, 0, 0 },
 { "player_skill", USERDEFS_PLAYER_SKILL, 0, 0 },
 { "level_number", USERDEFS_LEVEL_NUMBER, 0, 0 },
 { "volume_number", USERDEFS_VOLUME_NUMBER, 0, 0 },
 { "m_marker", USERDEFS_M_MARKER, 0, 0 },
 { "marker", USERDEFS_MARKER, 0, 0 },
 { "mouseflip", USERDEFS_MOUSEFLIP, 0, 0 },

  { "", -1, 0, 0  }     // END OF LIST
        
};


///////////////////////////////////////////


#endif

void ReportError( int iError)
{
        switch(iError)
        {
                case ERROR_ISAKEYWORD:
                        printf("  * ERROR!(L%ld) Symbol '%s' is a key word.\n",
                                   line_number,label+(labelcnt<<6));
                        break;
                case ERROR_PARMUNDEFINED:
                        printf("  * ERROR!(L%ld) Parameter '%s' is undefined.\n",
                                   line_number,tempbuf);
                        break;
                case WARNING_DUPLICATEDEFINITION:
                        printf("  * WARNING.(L%ld) Duplicate definition '%s' ignored.\n",
                                   line_number,label+(labelcnt<<6));
                        break;
                case ERROR_COULDNOTFIND:
                        printf("  * ERROR!(L%ld) Could not find '%s'.\n",
                                   line_number,label+(labelcnt<<6));
                        break;
                case ERROR_VARREADONLY:
                        printf("  * ERROR!(L%ld) Variable '%s' is read-only.\n",
                                   line_number,label+(labelcnt<<6));
                        break;
                case ERROR_NOTAGAMEDEF:
                        printf("  * ERROR!(L%ld) Symbol '%s' is not a Game Definition.\n",
                                   line_number,label+(labelcnt<<6));
                        break;
                case ERROR_SYMBOLNOTRECOGNIZED:
                        printf("  * ERROR! %s(L%ld) Symbol '%s' is not recognized.\n",
                                   g_achSourceFiles[g_currentSourceFile],
                                   line_number,label+(labelcnt<<6));
                        break;
                case ERROR_EXPECTINGKEYWORD:
                        printf("  * ERROR! %s(L%ld) Expecting key word, but found '%s'.\n",
                                   g_achSourceFiles[g_currentSourceFile],
                                   line_number,tempbuf);
                        break;
                case ERROR_NOTAGAMEVAR:
                        printf("  * ERROR! %s(L%ld) Symbol '%s' is not a defined Game Variable.\n",
                                   g_achSourceFiles[g_currentSourceFile],
                                   line_number,label+(labelcnt<<6));
                        break;
                case ERROR_OPENBRACKET:
                        printf("  * ERROR!%s(L%ld) Found more '{' than '}' before '%s'.\n",
                                   g_achSourceFiles[g_currentSourceFile],
                                   line_number, tempbuf);
                        break;
                case ERROR_CLOSEBRACKET:
                        printf("  * ERROR!%s(L%ld) Found more '}' than '{' before '%s'.\n",
                                   g_achSourceFiles[g_currentSourceFile],
                                   line_number, tempbuf);
                        break;
                case ERROR_NOENDSWITCH:
                        printf("  * ERROR!%s(L%ld) Did not find endswitch before '%s'.\n",
                                   g_achSourceFiles[g_currentSourceFile],
                                   line_number, tempbuf);
                        break;
                        
        }
}

char ispecial(char c)
{
        if(c == 0x0a)
        {
                line_number++;
                return 1;
        }

        if(c == ' ' || c == 0x0d)
                return 1;

        return 0;
}

char isaltok(char c)
{
        return ( isalnum(c) || c == '{' || c == '}' || c == '/' || c == '*' || c == '-' || c == '_' || c == '.');
}



long getlabelid(LABELS *pLabel, char *psz)
{
        // find the label psz in the table pLabel.
        // returns the ID for the label, or -1
        
        long l=-1;
        int i;

        for(i=0;pLabel[i].lId >=0 ; i++)
        {
                if(!stricmp(pLabel[i].name,psz))
                {
                        l= pLabel[i].lId;
                        break;  // stop for loop
                }
        }
        if( l>=0 && pLabel[i].flags)
        {
//printf("Label has flags of %02X\n",pLabel[i].flags);
        }
        return l;
}


long getlabeloffset(LABELS *pLabel, char *psz)
{
        // find the label psz in the table pLabel.
        // returns the offset in the array for the label, or -1
        long l=-1;
        int i;

        for(i=0;pLabel[i].lId >=0 ; i++)
        {
                if(!stricmp(pLabel[i].name,psz))
                {
//      printf("Label has flags of %02X\n",pLabel[i].flags);
                        return i;
                }
        }
        return -1;
}


void getlabel(void)
{
        long i;

        while( isalnum(*textptr) == 0 )
        {
                if(*textptr == 0x0a) line_number++;
                textptr++;
                if( *textptr == 0)
                        return;
        }

        i = 0;
#ifdef EDUKE
        while( ispecial(*textptr) == 0 && *textptr!=']' )
#else
        while( ispecial(*textptr) == 0 )
#endif
                label[(labelcnt<<6)+i++] = *(textptr++);

        label[(labelcnt<<6)+i] = 0;
}

long keyword(void)
{
        long i;
        char *temptextptr;

        temptextptr = textptr;

        while( isaltok(*temptextptr) == 0 )
        {
                temptextptr++;
                if( *temptextptr == 0 )
                        return 0;
        }

        i = 0;
        while( isaltok(*temptextptr) )
        {
                tempbuf[i] = *(temptextptr++);
                i++;
        }
        tempbuf[i] = 0;

        for(i=0;i<NUMKEYWORDS;i++)
                if( strcmp( tempbuf,keyw[i]) == 0 )
                        return i;

        return -1;
}

long transword(void) //Returns its code #
{
        long i, l;

        while( isaltok(*textptr) == 0 )
        {
                if(*textptr == 0x0a) line_number++;
                if( *textptr == 0 )
                        return -1;
                textptr++;
        }

        l = 0;
        while( isaltok(*(textptr+l)) && !(*(textptr + l) == '.') )
        {
                tempbuf[l] = textptr[l];
                l++;
        }
        tempbuf[l] = 0;

        for(i=0;i<NUMKEYWORDS;i++)
        {
                if( strcmp( tempbuf,keyw[i]) == 0 )
                {
                        *scriptptr = i;
                        textptr += l;
                        scriptptr++;
                        return i;
                }
        }

        textptr += l;

        if( tempbuf[0] == '{' && tempbuf[1] != 0)
                printf("  * ERROR!(L%ld) Expecting a SPACE or CR between '{' and '%s'.\n",line_number,tempbuf+1);
        else if( tempbuf[0] == '}' && tempbuf[1] != 0)
                printf("  * ERROR!(L%ld) Expecting a SPACE or CR between '}' and '%s'.\n",line_number,tempbuf+1);
        else if( tempbuf[0] == '/' && tempbuf[1] == '/' && tempbuf[2] != 0 )
                printf("  * ERROR!(L%ld) Expecting a SPACE between '//' and '%s'.\n",line_number,tempbuf+2);
        else if( tempbuf[0] == '/' && tempbuf[1] == '*' && tempbuf[2] != 0 )
                printf("  * ERROR!(L%ld) Expecting a SPACE between '/*' and '%s'.\n",line_number,tempbuf+2);
        else if( tempbuf[0] == '*' && tempbuf[1] == '/' && tempbuf[2] != 0 )
                printf("  * ERROR!(L%ld) Expecting a SPACE between '*/' and '%s'.\n",line_number,tempbuf+2);
        else ReportError(ERROR_EXPECTINGKEYWORD);

        error++;
        return -1;
}

void transnum(void)
{
        long i, l;

        while( isaltok(*textptr) == 0 )
        {
                if(*textptr == 0x0a) line_number++;
                textptr++;
                if( *textptr == 0 )
                        return;
        }


        l = 0;
        while( isaltok(*(textptr+l)) )
        {
                tempbuf[l] = textptr[l];
                l++;
        }
        tempbuf[l] = 0;

        for(i=0;i<NUMKEYWORDS;i++)
                if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
        {
                error++;
                ReportError(ERROR_ISAKEYWORD);
                textptr+=l;
        }


        for(i=0;i<labelcnt;i++)
        {
                if( strcmp(tempbuf,label+(i<<6)) == 0 )
                {
                        *scriptptr = labelcode[i];
                        scriptptr++;
                        textptr += l;
                        return;
                }
        }

        if( isdigit(*textptr) == 0 && *textptr != '-')
        {
                ReportError(ERROR_PARMUNDEFINED);
                error++;
                textptr+=l;
                if (GetDefID(tempbuf)>=0)
                {
                        printf("     Game Variable not expected\n");
                }
                return;
        }

        *scriptptr = atol(textptr);
        scriptptr++;

        textptr += l;
}

#ifdef EDUKE
long CountCaseStatements()
{
        long lCount;
        char *temptextptr;
        long *savescript;
        long *savecase;
        short temp_line_number;


        temp_line_number=line_number;

        casecount=0;
        temptextptr=textptr;
        savescript=scriptptr;
        savecase=casescriptptr;
        casescriptptr=NULL;
//sprintf(g_szBuf,"CSS: %.12s",textptr);
//AddLog(g_szBuf);
        while(parsecommand() == 0)
        {
//sprintf(g_szBuf,"CSSL: %.20s",textptr);
//AddLog(g_szBuf);
                  ;
        }
        // since we processed the endswitch, we need to re-increment checking_switch
        checking_switch++;
        
        textptr=temptextptr;
        scriptptr=savescript;

        line_number = temp_line_number;
         
        lCount=casecount;
        casecount=0;
        casescriptptr=savecase;
        return lCount;
}
#endif


char parsecommand(void)
{
        long i, j, k, *tempscrptr;
        char done, *origtptr, temp_ifelse_check, tw;
        short temp_line_number;
        int temp_current_file;
        int fp;
#ifdef EDUKE
        char *temptextptr;
#endif

#ifdef WW2
        if( (error+warning) > 12 || ( *textptr == '\0' ) || ( *(textptr+1) == '\0' ) ) return 1;
#else
        if( error > 12 || ( *textptr == '\0' ) || ( *(textptr+1) == '\0' ) ) return 1;
#endif

if (checking_switch> 0 )
{
//sprintf(g_szBuf,"PC(): '%.25s'",textptr);
//AddLog(g_szBuf);
}

        tw = transword();

        switch(tw)
        {
                default:
                case -1:
                        return 0; //End
                case 39:          //Rem endrem
                        scriptptr--;
                        j = line_number;
                        do
                        {
                                textptr++;
                                if(*textptr == 0x0a) line_number++;
                                if( *textptr == 0 )
                                {
                                        printf("  * ERROR!(L%ld) Found '/*' with no '*/'.\n",j,label+(labelcnt<<6));
                                        error++;
                                        return 0;
                                }
                        }
                        while( *textptr != '*' || *(textptr+1) != '/' );
                        textptr+=2;
                        return 0;
                case 17:
                        if( parsing_actor == 0 && parsing_state == 0 )
                        {
                                getlabel();
                                scriptptr--;
                                labelcode[labelcnt] = (long) scriptptr;
                                labelcnt++;

                                parsing_state = 1;

                                return 0;
                        }

                        getlabel();

                        for(i=0;i<NUMKEYWORDS;i++)
                                if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                {
                                        error++;
                                        ReportError(ERROR_ISAKEYWORD);
                                        return 0;
                                }

                        for(j=0;j<labelcnt;j++)
                        {
                                if( strcmp(label+(j<<6),label+(labelcnt<<6)) == 0 )
                                {
                                        *scriptptr = labelcode[j];
                                        break;
                                }
                        }

                        if(j==labelcnt)
                        {
                                printf("  * ERROR!(L%ld) State '%s' not found.\n",line_number,label+(labelcnt<<6));
                                error++;
                        }
                        scriptptr++;
                        return 0;

                case 15:
                case 92:
                case 87:
                case 89:
                case 93:
                        transnum();
                        return 0;
                        
                case CON_IFSOUND:
                        transnum();
                        tempscrptr = scriptptr;
                        scriptptr++; //Leave a spot for the fail location
                        return 0;

                case 18:
                        if( parsing_state == 0 )
                        {
                                printf("  * ERROR!(L%ld) Found 'ends' with no 'state'.\n",line_number);
                                error++;
                        }
//                        else
                        {
                                if( num_squigilly_brackets > 0 )
                                {
                                        ReportError(ERROR_CLOSEBRACKET);
                                        error++;
                                }
                                if( num_squigilly_brackets < 0 )
                                {
                                        ReportError(ERROR_CLOSEBRACKET);
                                        error++;
                                }
                                if( checking_switch > 0  )
                                {
                                        ReportError(ERROR_NOENDSWITCH);
                                        error++;

                                        checking_switch = 0; // can't be checking anymore...
                                }
                                parsing_state = 0;
                        }
                        return 0;
#ifdef WW2
                case CON_GAMEVAR:
                        // syntax: gamevar <var1> <initial value> <flags>
                        // defines var1 and sets initial value.
                        // flags are used to define usage
                        // (see top of this files for flags)
//printf("Got gamedef. Getting Label. '%.20s'\n",textptr);
                        getlabel();     //GetGameVarLabel();
//printf("Got Label '%.20s'\n",textptr);
                        // Check to see it's already defined

                        for(i=0;i<NUMKEYWORDS;i++)
                                if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                {
                                        error++;
                                        ReportError(ERROR_ISAKEYWORD);
                                        return 0;
                                }

#if 0                   
                        for(i=0;i<iGameVarCount;i++)
                        {
                                if( strcmp(label+(labelcnt<<6),apszGameVarLabel[i]) == 0 )
                                {
                                        warning++;
                                        printf("  * WARNING.(L%ld) Duplicate Game definition '%s' ignored.\n",line_number,label+(labelcnt<<6));
                                        break;
                                }
                        }
#endif                  

//printf("Translating number  '%.20s'\n",textptr);                      
                        transnum();     // get initial value
//printf("Done Translating number.      '%.20s'\n",textptr);

                        transnum();     // get flags
//sprintf(g_szBuf,"Adding GameVar='%s', val=%l, flags=%lX",label+(labelcnt<<6),
//              *(scriptptr-2), *(scriptptr-1));
//AddLog(g_szBuf);
                        
                        AddGameVar(label+(labelcnt<<6),*(scriptptr-2),
                                           (*(scriptptr-1))
                                                // can't define default or secret
                                           & (~( GAMEVAR_FLAG_DEFAULT | GAMEVAR_FLAG_SECRET))
                                          );
//AddLog("Added gamevar");
                        scriptptr -= 3; // no need to save in script...
                        return 0;
#endif                  
                case 19:
//printf("Got definition. Getting Label. '%.20s'\n",textptr);
                        getlabel();
//printf("Got label. '%.20s'\n",textptr);
                        // Check to see it's already defined

                        for(i=0;i<NUMKEYWORDS;i++)
                                if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                {
                                        error++;
                                        ReportError(ERROR_ISAKEYWORD);
                                        return 0;
                                }

                        for(i=0;i<labelcnt;i++)
                        {
                                if( strcmp(label+(labelcnt<<6),label+(i<<6)) == 0 )
                                {
                                        warning++;
                                        ReportError(WARNING_DUPLICATEDEFINITION);
                                        break;
                                }
                        }

//printf("Translating. '%.20s'\n",textptr);
                        transnum();
//printf("Translated. '%.20s'\n",textptr);
                        if(i == labelcnt)
                        {
//                              printf("Defining Definition '%s' to be '%d'\n",label+(labelcnt<<6),*(scriptptr-1));
                                labelcode[labelcnt++] = *(scriptptr-1);
                        }
                        scriptptr -= 2;
                        return 0;
                case 14:

                        for(j = 0;j < 4;j++)
                        {
                                if( keyword() == -1 )
                                        transnum();
                                else break;
                        }

                        while(j < 4)
                        {
                                *scriptptr = 0;
                                scriptptr++;
                                j++;
                        }
                        return 0;

                case 32:
                        if( parsing_actor || parsing_state )
                        {
                                transnum();

                                j = 0;
                                while(keyword() == -1)
                                {
                                        transnum();
                                        scriptptr--;
                                        j |= *scriptptr;
                                }
                                *scriptptr = j;
                                scriptptr++;
                        }
                        else
                        {
                                scriptptr--;
                                getlabel();
                                // Check to see it's already defined

                                for(i=0;i<NUMKEYWORDS;i++)
                                        if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                {
                                        error++;
                                        ReportError(ERROR_ISAKEYWORD);
                                        return 0;
                                }

                                for(i=0;i<labelcnt;i++)
                                        if( strcmp(label+(labelcnt<<6),label+(i<<6)) == 0 )
                                        {
                                                warning++;
                                                printf("  * WARNING.(L%ld) Duplicate move '%s' ignored.\n",line_number,label+(labelcnt<<6));
                                                break;
                                        }
                                if(i == labelcnt)
                                        labelcode[labelcnt++] = (long) scriptptr;
                                for(j=0;j<2;j++)
                                {
                                        if(keyword() >= 0) break;
                                        transnum();
                                }
                                for(k=j;k<2;k++)
                                {
                                        *scriptptr = 0;
                                        scriptptr++;
                                }
                        }
                        return 0;

                case 54:
                        {
                                // NOTE: this doesn't get stored in the PCode...
                                
// music 1 stalker.mid dethtoll.mid streets.mid watrwld1.mid snake1.mid
//        thecall.mid ahgeez.mid dethtoll.mid streets.mid watrwld1.mid snake1.mid
                                scriptptr--;
                                transnum(); // Volume Number (0/4)
                                scriptptr--;

                                k = *scriptptr-1;

                                if(k >= 0) // if it's background music
                                {
                                        i = 0;
                                        // get the file name...
                                        while(keyword() == -1)
                                        {
                                                while( isaltok(*textptr) == 0 )
                                                {
                                                        if(*textptr == 0x0a) line_number++;
                                                        textptr++;
                                                        if( *textptr == 0 ) break;
                                                }
                                                j = 0;
                                                while( isaltok(*(textptr+j)) )
                                                {
                                                        music_fn[k][i][j] = textptr[j];
                                                        j++;
                                                }
                                                music_fn[k][i][j] = '\0';
                                                textptr += j;
                                                if(i > 9) break;
                                                i++;
                                        }
                                }
                                else
                                {
                                        i = 0;
                                        while(keyword() == -1)
                                        {
                                                while( isaltok(*textptr) == 0 )
                                                {
                                                        if(*textptr == 0x0a) line_number++;
                                                        textptr++;
                                                        if( *textptr == 0 ) break;
                                                }
                                                j = 0;
                                                while( isaltok(*(textptr+j)) )
                                                {
                                                        env_music_fn[i][j] = textptr[j];
                                                        j++;
                                                }
                                                env_music_fn[i][j] = '\0';

                                                textptr += j;
                                                if(i > 9) break;
                                                i++;
                                        }
                                }
                        }
                        return 0;
                case 55:
                        scriptptr--;
                        while( isaltok(*textptr) == 0 )
                        {
                                if(*textptr == 0x0a) line_number++;
                                textptr++;
                                if( *textptr == 0 ) break;
                        }
                        j = 0;
                        while( isaltok(*textptr) )
                        {
                                tempbuf[j] = *(textptr++);
                                j++;
                        }
                        tempbuf[j] = '\0';

                        fp = kopen4load(tempbuf,loadfromgrouponly);
                        if(fp == 0)
                        {
                                error++;
                                ReportError(ERROR_COULDNOTFIND);
                                return 0;
                        }

                        j = kfilelength(fp);

                        printf("Including: '%s'.\n",tempbuf);

                        temp_current_file=g_currentSourceFile;
                        
                        AddSourceFile(tempbuf);

                        temp_line_number = line_number;
                        line_number = 1;
                        temp_ifelse_check = checking_ifelse;
                        checking_ifelse = 0;
                        origtptr = textptr;
                        textptr = last_used_text+last_used_size;

                        *(textptr+j) = 0;

                        kread(fp,(char *)textptr,j);
                        kclose(fp);

//sprintf(g_szBuf,"CP:%s %d",__FILE__,__LINE__);
//AddLog(g_szBuf);
                        do
                                done = parsecommand();
                        while( done == 0 );

                        textptr = origtptr;
                        total_lines += line_number;
                        line_number = temp_line_number;
                        checking_ifelse = temp_ifelse_check;
                        g_currentSourceFile=temp_current_file;
//sprintf(g_szBuf,"CP:%s %d",__FILE__,__LINE__);
//AddLog(g_szBuf);
                        PopSourceFile();

                        return 0;
                case 24:
                        if( parsing_actor || parsing_state )
                                transnum();
                        else
                        {
                                scriptptr--;
                                getlabel();

                                for(i=0;i<NUMKEYWORDS;i++)
                                        if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                        {
                                                error++;
                                                ReportError(ERROR_ISAKEYWORD);
                                                return 0;
                                        }

                                for(i=0;i<labelcnt;i++)
                                        if( strcmp(label+(labelcnt<<6),label+(i<<6)) == 0 )
                                        {
                                                warning++;
                                                printf("  * WARNING.(L%ld) Duplicate ai '%s' ignored.\n",line_number,label+(labelcnt<<6));
                                                break;
                                        }

                                if(i == labelcnt)
                                        labelcode[labelcnt++] = (long) scriptptr;

                                for(j=0;j<3;j++)
                                {
                                        if(keyword() >= 0) break;
                                        if(j == 2)
                                        {
                                                k = 0;
                                                while(keyword() == -1)
                                                {
                                                        transnum();
                                                        scriptptr--;
                                                        k |= *scriptptr;
                                                }
                                                *scriptptr = k;
                                                scriptptr++;
                                                return 0;
                                        }
                                        else transnum();
                                }
                                for(k=j;k<3;k++)
                                {
                                        *scriptptr = 0;
                                        scriptptr++;
                                }
                        }
                        return 0;

                case 7:
                        if( parsing_actor || parsing_state )
                                transnum();
                        else
                        {
                                scriptptr--;
                                getlabel();
                                // Check to see it's already defined

                                for(i=0;i<NUMKEYWORDS;i++)
                                        if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                        {
                                                error++;
                                                ReportError(ERROR_ISAKEYWORD);
                                                return 0;
                                        }

                                for(i=0;i<labelcnt;i++)
                                        if( strcmp(label+(labelcnt<<6),label+(i<<6)) == 0 )
                                        {
                                                warning++;
                                                printf("  * WARNING.(L%ld) Duplicate event '%s' ignored.\n",line_number,label+(labelcnt<<6));
                                                break;
                                        }

                                if(i == labelcnt)
                                        labelcode[labelcnt++] = (long) scriptptr;

                                for(j=0;j<5;j++)
                                {
                                        if(keyword() >= 0) break;
                                        transnum();
                                }
                                for(k=j;k<5;k++)
                                {
                                        *scriptptr = 0;
                                        scriptptr++;
                                }
                        }
                        return 0;

                case 1:
                        if( parsing_state )
                        {
                                printf("  * ERROR!(L%ld) Found 'actor' within 'state'.\n",line_number);
                                error++;
                        }

                        if( parsing_actor )
                        {
                                printf("  * ERROR!(L%ld) Found 'actor' within 'actor'.\n",line_number);
                                error++;
                        }

                        num_squigilly_brackets = 0;
                        scriptptr--;
                        parsing_actor = scriptptr;

                        transnum();
                        scriptptr--;
                        actorscrptr[*scriptptr] = parsing_actor;

                        for(j=0;j<4;j++)
                        {
                                *(parsing_actor+j) = 0;
                                if(j == 3)
                                {
                                        j = 0;
                                        while(keyword() == -1)
                                        {
                                                transnum();
                                                scriptptr--;
                                                j |= *scriptptr;
                                        }
                                        *scriptptr = j;
                                        scriptptr++;
                                        break;
                                }
                                else
                                {
                                        if(keyword() >= 0)
                                        {
                                                scriptptr += (4-j);
                                                break;
                                        }
                                        transnum();

                                        *(parsing_actor+j) = *(scriptptr-1);
                                }
                        }

                        checking_ifelse = 0;

                        return 0;

#ifdef WW2
                case CON_ONEVENT:
                        if( parsing_state )
                        {
                                printf("  * ERROR!(L%ld) Found 'onevent' within 'state'.\n",line_number);
                                error++;
                        }

                        if( parsing_actor )
                        {
                                printf("  * ERROR!(L%ld) Found 'onevent' within 'actor'.\n",line_number);
                                error++;
                        }

                        num_squigilly_brackets = 0;
                        scriptptr--;
                        parsing_event = scriptptr;
                        parsing_actor = scriptptr;

                        transnum();
                        scriptptr--;
                        j= *scriptptr;  // type of event
//sprintf(g_szBuf,"Adding Event for %d at %lX",j, parsing_event);
//AddLog(g_szBuf);
                        if(j< 0 || j> EVENT_MAXEVENT)
                        {
                                printf("  * ERROR!(L%ld) Invalid Event ID.\n",line_number);
                                error++;
                                return 0;
                        }
                        switch(j)
                        {
                                case EVENT_CHEATGETSTEROIDS:
                                case EVENT_CHEATGETHEAT:
                                case EVENT_CHEATGETBOOT:
                                case EVENT_CHEATGETSHIELD:
                                case EVENT_CHEATGETSCUBA:
                                case EVENT_CHEATGETHOLODUKE:
                                case EVENT_CHEATGETJETPACK:
                                case EVENT_CHEATGETFIRSTAID:
                                        localplayeronly=1;
                                        break;
                                        

                        }
                        apScriptGameEvent[j]=parsing_event;
                        
                        checking_ifelse = 0;

                        return 0;
#ifdef EDUKE
                case CON_EVENTLOADACTOR:

                        if( parsing_state )
                        {
                                printf("  * ERROR!(L%ld) Found '%s' within 'state'.\n",keyw[tw],line_number);
                                error++;
                        }

                        if( parsing_actor )
                        {
                                printf("  * ERROR!(L%ld) Found '%s' within 'actor'.\n",keyw[tw],line_number);
                                error++;
                        }

                        num_squigilly_brackets = 0;
                        scriptptr--;
                        parsing_actor = scriptptr;

                        transnum();
                        scriptptr--;
                        actorLoadEventScrptr[*scriptptr] = parsing_actor;

                        checking_ifelse = 0;

                        return 0;
#endif // EDUKE                 
#endif // WW2GI

                case 98:

                        if( parsing_state )
                        {
                                printf("  * ERROR!(L%ld) Found 'useractor' within 'state'.\n",line_number);
                                error++;
                        }

                        if( parsing_actor )
                        {
                                printf("  * ERROR!(L%ld) Found 'useractor' within 'actor'.\n",line_number);
                                error++;
                        }

                        num_squigilly_brackets = 0;
                        scriptptr--;
                        parsing_actor = scriptptr;

                        transnum();
                        scriptptr--;
                        j = *scriptptr;

                        transnum();
                        scriptptr--;
                        actorscrptr[*scriptptr] = parsing_actor;
                        actortype[*scriptptr] = j;

                        for(j=0;j<4;j++)
                        {
                                *(parsing_actor+j) = 0;
                                if(j == 3)
                                {
                                        j = 0;
                                        while(keyword() == -1)
                                        {
                                                transnum();
                                                scriptptr--;
                                                j |= *scriptptr;
                                        }
                                        *scriptptr = j;
                                        scriptptr++;
                                        break;
                                }
                                else
                                {
                                        if(keyword() >= 0)
                                        {
                                                scriptptr += (4-j);
                                                break;
                                        }
                                        transnum();

                                        *(parsing_actor+j) = *(scriptptr-1);
                                }
                        }

                        checking_ifelse = 0;

                        return 0;

                case 11:
                case 13:
                case 25:
                case 31:
                case 40:
                case 52:
                case 69:
                case 74:
                case 77:
                case 80:
                case 86:
                case 88:
                case 68:
                case 100:
                case 101:
                case 102:
                case 103:
                case 105:
                case 110:
#ifdef EDUKE
                case CON_ESPAWN:
#endif
                        transnum();
                        return 0;

                case 2:
                case 23:
                case 28:
                case 99:
                case 37:
                case 48:
                case 58:
                        transnum();
                        transnum();
                        break;
                case 50:
                        transnum();
                        transnum();
                        transnum();
                        transnum();
                        transnum();
                        break;
                case 10:
                        if( checking_ifelse )
                        {
                                checking_ifelse--;
                                tempscrptr = scriptptr;
                                scriptptr++; //Leave a spot for the fail location
                                parsecommand();
                                *tempscrptr = (long) scriptptr;
                        }
                        else
                        {
                                scriptptr--;
                                error++;
                                printf("  * ERROR!(L%ld) Found 'else' with no 'if'.\n",line_number);
                        }

                        return 0;
#ifdef EDUKE
                case CON_SETSECTOR:
                case CON_GETSECTOR:
                {
                        long lLabelID;
                        // syntax getsector[<var>].x <VAR>
                        // gets the value of sector[<var>].xxx into <VAR>
                        
                        // now get name of .xxx
                        while((*textptr != '['))
                        {
                                textptr++;
                        }
                        if(*textptr == '[')
                                textptr++;
                
                        // get the ID of the DEF
                        getlabel();     //GetGameVarLabel();
//printf("found label of '%s'\n",       label+(labelcnt<<6));

                        // Check to see if it's a keyword
                        for(i=0;i<NUMKEYWORDS;i++)
                                if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                {
                                        error++;
                                        ReportError(ERROR_ISAKEYWORD);
                                        return 0;
                                }

                        i=GetDefID(label+(labelcnt<<6));
//printf("Label '%s' ID is %d\n",label+(labelcnt<<6), i);
                        if(i<0)
                        {       // not a defined DEF
                                error++;
                                ReportError(ERROR_NOTAGAMEDEF);
                                return 0;
                        }
#if 0
                        if(aGameVars[i].dwFlags & GAMEVAR_FLAG_READONLY)
                        {
                                error++;
                                printf("  * ERROR!(L%ld) Variable '%s' is read-only.\n",line_number,label+(labelcnt<<6));
                                return 0;
                                
                        }
#endif                  
                        *scriptptr++=i; // the ID of the DEF (offset into array...)

                        // now get name of .xxx
                        while(*textptr != '.')
                        {
                                if(*textptr == 0xa)
                                        break;
                                if(!*textptr)
                                        break;
                                
                                textptr++;
                        }
                        if(*textptr!='.')
                        {
                                error++;
                                printf("  * ERROR!(L%ld) Syntax error\n",line_number);
                                return 0;
                        
                        }
                        textptr++;
                        /// now pointing at 'xxx'
                        getlabel();
//printf("found xxx label of '%s'\n",   label+(labelcnt<<6));

                        lLabelID=getlabeloffset(sectorlabels,label+(labelcnt<<6));

                        if(lLabelID == -1 )
                        {
                                error++;
                                ReportError(ERROR_SYMBOLNOTRECOGNIZED);
                                return 0;
                        }
                        *scriptptr++=sectorlabels[lLabelID].lId;
//#Pragma ERROR Still need to add runvar processing and other comp processing
                        if (sectorlabels[lLabelID].flags & LABEL_HASPARM2)
                        {
                                // get parm2
                        // get the ID of the DEF
                                getlabel();     //GetGameVarLabel();
//printf("found label of '%s'\n",       label+(labelcnt<<6));

                        // Check to see if it's a keyword
                                for(i=0;i<NUMKEYWORDS;i++)
                                        if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                        {
                                                error++;
                                                ReportError(ERROR_ISAKEYWORD);
                                                return 0;
                                        }

                                i=GetDefID(label+(labelcnt<<6));
//printf("Label '%s' ID is %d\n",label+(labelcnt<<6), i);
                                if(i<0)
                                {       // not a defined DEF
                                        error++;
                                        ReportError(ERROR_NOTAGAMEDEF);
                                        return 0;
                                }
                                *scriptptr++=i; // the ID of the DEF (offset into array...)
                        }

                        // now at target VAR...
                        
                        // get the ID of the DEF
                        getlabel();     //GetGameVarLabel();
//printf("found label of '%s'\n",       label+(labelcnt<<6));

                        // Check to see if it's a keyword
                        for(i=0;i<NUMKEYWORDS;i++)
                                if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                {
                                        error++;
                                        ReportError(ERROR_ISAKEYWORD);
                                        return 0;
                                }

                        i=GetDefID(label+(labelcnt<<6));
//printf("Label '%s' ID is %d\n",label+(labelcnt<<6), i);
                        if(i<0)
                        {       // not a defined DEF
                                error++;
                                ReportError(ERROR_NOTAGAMEDEF);
                                return 0;
                        }
#if 1
                        if(tw == CON_GETSECTOR && aGameVars[i].dwFlags & GAMEVAR_FLAG_READONLY)
                        {
                                error++;
                                printf("  * ERROR!(L%ld) Variable '%s' is read-only.\n",line_number,label+(labelcnt<<6));
                                return 0;
                                
                        }
#endif                  
                        *scriptptr++=i; // the ID of the DEF (offset into array...)

                        break;
                }
                case CON_FINDNEARACTOR:
                {
                        // syntax findnearactor <type> <maxdist> <getvar>
                        // gets the sprite ID of the nearest actor within max dist
                        // that is of <type> into <getvar>
                        // -1 for none found

                        transnum();     // get <type>

                        transnum(); // get maxdist
                        
                        // target var
                        // get the ID of the DEF
                        getlabel();     //GetGameVarLabel();
//printf("found label of '%s'\n",       label+(labelcnt<<6));

                        // Check to see if it's a keyword
                        for(i=0;i<NUMKEYWORDS;i++)
                                if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                {
                                        error++;
                                        ReportError(ERROR_ISAKEYWORD);
                                        return 0;
                                }

                        i=GetDefID(label+(labelcnt<<6));
//printf("Label '%s' ID is %d\n",label+(labelcnt<<6), i);
                        if(i<0)
                        {       // not a defined DEF
                                error++;
                                ReportError(ERROR_NOTAGAMEDEF);
                                return 0;
                        }
#if 1
                        if(aGameVars[i].dwFlags & GAMEVAR_FLAG_READONLY)
                        {
                                error++;
                                ReportError(ERROR_VARREADONLY);
                                return 0;
                                
                        }
#endif                  
                        *scriptptr++=i; // the ID of the DEF (offset into array...)
                        
                        break;
                }
                case CON_FINDNEARACTORVAR:
                {
                        // syntax findnearactorvar <type> <maxdistvar> <getvar>
                        // gets the sprite ID of the nearest actor within max dist
                        // that is of <type> into <getvar>
                        // -1 for none found

                        transnum();     // get <type>
                                                
                        // get the ID of the DEF
                        getlabel();     //GetGameVarLabel();
//printf("found label of '%s'\n",       label+(labelcnt<<6));

                        // Check to see if it's a keyword
                        for(i=0;i<NUMKEYWORDS;i++)
                                if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                {
                                        error++;
                                        ReportError(ERROR_ISAKEYWORD);
                                        return 0;
                                }

                        i=GetDefID(label+(labelcnt<<6));
//printf("Label '%s' ID is %d\n",label+(labelcnt<<6), i);
                        if(i<0)
                        {       // not a defined DEF
                                error++;
                                ReportError(ERROR_NOTAGAMEDEF);
                                return 0;
                        }
#if 0
                        if(aGameVars[i].dwFlags & GAMEVAR_FLAG_READONLY)
                        {
                                error++;
                                ReportError(ERROR_VARREADONLY);
                                return 0;
                                
                        }
#endif                  
                        *scriptptr++=i; // the ID of the DEF (offset into array...)
                        
                        // target var
                        // get the ID of the DEF
                        getlabel();     //GetGameVarLabel();
//printf("found label of '%s'\n",       label+(labelcnt<<6));

                        // Check to see if it's a keyword
                        for(i=0;i<NUMKEYWORDS;i++)
                                if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                {
                                        error++;
                                        ReportError(ERROR_ISAKEYWORD);
                                        return 0;
                                }

                        i=GetDefID(label+(labelcnt<<6));
//printf("Label '%s' ID is %d\n",label+(labelcnt<<6), i);
                        if(i<0)
                        {       // not a defined DEF
                                error++;
                                ReportError(ERROR_NOTAGAMEDEF);
                                return 0;
                        }
#if 1
                        if(aGameVars[i].dwFlags & GAMEVAR_FLAG_READONLY)
                        {
                                error++;
                                ReportError(ERROR_VARREADONLY);
                                return 0;
                                
                        }
#endif                  
                        *scriptptr++=i; // the ID of the DEF (offset into array...)
                        
                        break;
                }
                case CON_SQRT:
                {
                        // syntax sqrt <invar> <outvar>
                        // gets the sqrt of invar into outvar
                                                
                        // get the ID of the DEF
                        getlabel();     //GetGameVarLabel();
//printf("found label of '%s'\n",       label+(labelcnt<<6));

                        // Check to see if it's a keyword
                        for(i=0;i<NUMKEYWORDS;i++)
                                if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                {
                                        error++;
                                        ReportError(ERROR_ISAKEYWORD);
                                        return 0;
                                }

                        i=GetDefID(label+(labelcnt<<6));
//printf("Label '%s' ID is %d\n",label+(labelcnt<<6), i);
                        if(i<0)
                        {       // not a defined DEF
                                error++;
                                ReportError(ERROR_NOTAGAMEDEF);
                                return 0;
                        }
#if 0
                        if(aGameVars[i].dwFlags & GAMEVAR_FLAG_READONLY)
                        {
                                error++;
                                ReportError(ERROR_VARREADONLY);
                                return 0;
                                
                        }
#endif                  
                        *scriptptr++=i; // the ID of the DEF (offset into array...)
                        
                        // target var
                        // get the ID of the DEF
                        getlabel();     //GetGameVarLabel();
//printf("found label of '%s'\n",       label+(labelcnt<<6));

                        // Check to see if it's a keyword
                        for(i=0;i<NUMKEYWORDS;i++)
                                if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                {
                                        error++;
                                        ReportError(ERROR_ISAKEYWORD);
                                        return 0;
                                }

                        i=GetDefID(label+(labelcnt<<6));
//printf("Label '%s' ID is %d\n",label+(labelcnt<<6), i);
                        if(i<0)
                        {       // not a defined DEF
                                error++;
                                ReportError(ERROR_NOTAGAMEDEF);
                                return 0;
                        }
#if 1
                        if(aGameVars[i].dwFlags & GAMEVAR_FLAG_READONLY)
                        {
                                error++;
                                ReportError(ERROR_VARREADONLY);
                                return 0;
                                
                        }
#endif                  
                        *scriptptr++=i; // the ID of the DEF (offset into array...)
                        
                        break;
                }
                case CON_SETWALL:
                case CON_GETWALL:
                {
                        long lLabelID;
                        // syntax getwall[<var>].x <VAR>
                        // gets the value of wall[<var>].xxx into <VAR>
                        
                        // now get name of .xxx
                        while((*textptr != '['))
                        {
                                textptr++;
                        }
                        if(*textptr == '[')
                                textptr++;
                
                        // get the ID of the DEF
                        getlabel();     //GetGameVarLabel();
//printf("found label of '%s'\n",       label+(labelcnt<<6));

                        // Check to see if it's a keyword
                        for(i=0;i<NUMKEYWORDS;i++)
                                if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                {
                                        error++;
                                        ReportError(ERROR_ISAKEYWORD);
                                        return 0;
                                }

                        i=GetDefID(label+(labelcnt<<6));
//printf("Label '%s' ID is %d\n",label+(labelcnt<<6), i);
                        if(i<0)
                        {       // not a defined DEF
                                error++;
                                ReportError(ERROR_NOTAGAMEDEF);
                                return 0;
                        }
#if 0
                        if(aGameVars[i].dwFlags & GAMEVAR_FLAG_READONLY)
                        {
                                error++;
                                ReportError(ERROR_VARREADONLY);
                                return 0;
                                
                        }
#endif                  
                        *scriptptr++=i; // the ID of the DEF (offset into array...)

                        // now get name of .xxx
                        while(*textptr != '.')
                        {
                                if(*textptr == 0xa)
                                        break;
                                if(!*textptr)
                                        break;
                                
                                textptr++;
                        }
                        if(*textptr!='.')
                        {
                                error++;
                                printf("  * ERROR!(L%ld) Syntax error\n",line_number);
                                return 0;
                        
                        }
                        textptr++;
                        /// now pointing at 'xxx'
                        getlabel();
//printf("found xxx label of '%s'\n",   label+(labelcnt<<6));

                        lLabelID=getlabeloffset(walllabels,label+(labelcnt<<6));
                        
                        if(lLabelID == -1 )
                        {
                                error++;
                                ReportError(ERROR_SYMBOLNOTRECOGNIZED);
                                return 0;
                        }
                        *scriptptr++=walllabels[lLabelID].lId;

                        if (walllabels[lLabelID].flags & LABEL_HASPARM2)
                        {
                                // get parm2
                        // get the ID of the DEF
                                getlabel();     //GetGameVarLabel();
//printf("found label of '%s'\n",       label+(labelcnt<<6));

                        // Check to see if it's a keyword
                                for(i=0;i<NUMKEYWORDS;i++)
                                        if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                        {
                                                error++;
                                                ReportError(ERROR_ISAKEYWORD);
                                                return 0;
                                        }

                                i=GetDefID(label+(labelcnt<<6));
//printf("Label '%s' ID is %d\n",label+(labelcnt<<6), i);
                                if(i<0)
                                {       // not a defined DEF
                                        error++;
                                        ReportError(ERROR_NOTAGAMEDEF);
                                        return 0;
                                }
                                *scriptptr++=i; // the ID of the DEF (offset into array...)
                        }

                        // now at target VAR...
                        
                        // get the ID of the DEF
                        getlabel();     //GetGameVarLabel();
//printf("found label of '%s'\n",       label+(labelcnt<<6));

                        // Check to see if it's a keyword
                        for(i=0;i<NUMKEYWORDS;i++)
                                if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                {
                                        error++;
                                        ReportError(ERROR_ISAKEYWORD);
                                        return 0;
                                }

                        i=GetDefID(label+(labelcnt<<6));
//printf("Label '%s' ID is %d\n",label+(labelcnt<<6), i);
                        if(i<0)
                        {       // not a defined DEF
                                error++;
                                ReportError(ERROR_NOTAGAMEDEF);
                                return 0;
                        }
#if 1
                        if(tw == CON_GETWALL && aGameVars[i].dwFlags & GAMEVAR_FLAG_READONLY)
                        {
                                error++;
                                ReportError(ERROR_VARREADONLY);
                                return 0;
                                
                        }
#endif                  
                        *scriptptr++=i; // the ID of the DEF (offset into array...)

                        break;
                }
                case CON_SETPLAYER:
                case CON_GETPLAYER:
                {
                        long lLabelID;
                        // syntax getwall[<var>].x <VAR>
                        // gets the value of wall[<var>].xxx into <VAR>
                        
                        // now get name of .xxx
                        while((*textptr != '['))
                        {
                                textptr++;
                        }
                        if(*textptr == '[')
                                textptr++;
                
                        // get the ID of the DEF
                        getlabel();     //GetGameVarLabel();
//printf("found label of '%s'\n",       label+(labelcnt<<6));

                        // Check to see if it's a keyword
                        for(i=0;i<NUMKEYWORDS;i++)
                                if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                {
                                        error++;
                                        ReportError(ERROR_ISAKEYWORD);
                                        return 0;
                                }

                        i=GetDefID(label+(labelcnt<<6));
//printf("Label '%s' ID is %d\n",label+(labelcnt<<6), i);
                        if(i<0)
                        {       // not a defined DEF
                                error++;
                                ReportError(ERROR_NOTAGAMEDEF);
                                return 0;
                        }
#if 0
                        if(aGameVars[i].dwFlags & GAMEVAR_FLAG_READONLY)
                        {
                                error++;
                                ReportError(ERROR_VARREADONLY);
                                return 0;
                                
                        }
#endif                  
                        *scriptptr++=i; // the ID of the DEF (offset into array...)

                        // now get name of .xxx
                        while(*textptr != '.')
                        {
                                if(*textptr == 0xa)
                                        break;
                                if(!*textptr)
                                        break;
                                
                                textptr++;
                        }
                        if(*textptr!='.')
                        {
                                error++;
                                printf("  * ERROR!(L%ld) Syntax error\n",line_number);
                                return 0;
                        
                        }
                        textptr++;
                        /// now pointing at 'xxx'
                        getlabel();
//printf("found xxx label of '%s'\n",   label+(labelcnt<<6));

                        lLabelID=getlabeloffset(playerlabels,label+(labelcnt<<6));
//printf("LabelID is %ld\n",lLabelID);                  
                        if(lLabelID == -1 )
                        {
                                error++;
                                ReportError(ERROR_SYMBOLNOTRECOGNIZED);
                                return 0;
                        }

                        *scriptptr++=playerlabels[lLabelID].lId;
                        
//printf("member's flags are: %02Xh\n",playerlabels[lLabelID].flags);
                        if (playerlabels[lLabelID].flags & LABEL_HASPARM2)
                        {
//printf("Member has PARM2\n");                         
                                // get parm2
                        // get the ID of the DEF
                                getlabel();     //GetGameVarLabel();
//printf("found label of '%s'\n",       label+(labelcnt<<6));

                        // Check to see if it's a keyword
                                for(i=0;i<NUMKEYWORDS;i++)
                                        if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                        {
                                                error++;
                                                ReportError(ERROR_ISAKEYWORD);
                                                return 0;
                                        }

                                i=GetDefID(label+(labelcnt<<6));
//printf("Label '%s' ID is %d\n",label+(labelcnt<<6), i);
                                if(i<0)
                                {       // not a defined DEF
                                        error++;
                                        ReportError(ERROR_NOTAGAMEDEF);
                                        return 0;
                                }
                                *scriptptr++=i; // the ID of the DEF (offset into array...)
                        }
                        else
                        {
//printf("Member does not have Parm2\n");                               
                        }

                        // now at target VAR...
                        
                        // get the ID of the DEF
                        getlabel();     //GetGameVarLabel();
//printf("found label of '%s'\n",       label+(labelcnt<<6));

                        // Check to see if it's a keyword
                        for(i=0;i<NUMKEYWORDS;i++)
                                if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                {
                                        error++;
                                        ReportError(ERROR_ISAKEYWORD);
                                        return 0;
                                }

                        i=GetDefID(label+(labelcnt<<6));
//printf("Label '%s' ID is %d\n",label+(labelcnt<<6), i);
                        if(i<0)
                        {       // not a defined DEF
                                error++;
                                ReportError(ERROR_NOTAGAMEDEF);
                                return 0;
                        }
#if 1
                        if(tw == CON_GETPLAYER && aGameVars[i].dwFlags & GAMEVAR_FLAG_READONLY)
                        {
                                error++;
                                ReportError(ERROR_VARREADONLY);
                                return 0;
                                
                        }
#endif                  
                        *scriptptr++=i; // the ID of the DEF (offset into array...)

                        break;
                }
                case CON_SETUSERDEF:
                case CON_GETUSERDEF:
                {
                        long lLabelID;
                        // syntax [gs]etuserdef.x <VAR>
                        // gets the value of ud.xxx into <VAR>

//AddLog("Got userdef");
        
                        // now get name of .xxx
                        while(*textptr != '.')
                        {
                                if(*textptr == 0xa)
                                        break;
                                if(!*textptr)
                                        break;
                                
                                textptr++;
                        }
                        if(*textptr!='.')
                        {
                                error++;
                                printf("  * ERROR!(L%ld) Syntax error\n",line_number);
                                return 0;
                        
                        }
                        textptr++;
                        /// now pointing at 'xxx'
                        getlabel();
//printf("found xxx label of '%s'\n",   label+(labelcnt<<6));

                        lLabelID=getlabeloffset(userdefslabels,label+(labelcnt<<6));
                        if(lLabelID == -1 )
                        {
                                error++;
                                ReportError(ERROR_SYMBOLNOTRECOGNIZED);
                                return 0;
                        }
                        *scriptptr++=userdefslabels[lLabelID].lId;

                        if (userdefslabels[lLabelID].flags & LABEL_HASPARM2)
                        {
                                // get parm2
                        // get the ID of the DEF
                                getlabel();     //GetGameVarLabel();
//printf("found label of '%s'\n",       label+(labelcnt<<6));

                        // Check to see if it's a keyword
                                for(i=0;i<NUMKEYWORDS;i++)
                                        if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                        {
                                                error++;
                                                ReportError(ERROR_ISAKEYWORD);
                                                return 0;
                                        }

                                i=GetDefID(label+(labelcnt<<6));
//printf("Label '%s' ID is %d\n",label+(labelcnt<<6), i);
                                if(i<0)
                                {       // not a defined DEF
                                        error++;
                                        ReportError(ERROR_NOTAGAMEDEF);
                                        return 0;
                                }
                                *scriptptr++=i; // the ID of the DEF (offset into array...)
                        }


                        // now at target VAR...
                        
                        // get the ID of the DEF
                        getlabel();     //GetGameVarLabel();
//printf("found label of '%s'\n",       label+(labelcnt<<6));

                        // Check to see if it's a keyword
                        for(i=0;i<NUMKEYWORDS;i++)
                                if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                {
                                        error++;
                                        ReportError(ERROR_ISAKEYWORD);
                                        return 0;
                                }

                        i=GetDefID(label+(labelcnt<<6));
//printf("Label '%s' ID is %d\n",label+(labelcnt<<6), i);
                        if(i<0)
                        {       // not a defined DEF
                                error++;
                                ReportError(ERROR_NOTAGAMEDEF);
                                return 0;
                        }
#if 1
                        if(tw == CON_GETPLAYER && aGameVars[i].dwFlags & GAMEVAR_FLAG_READONLY)
                        {
                                error++;
                                ReportError(ERROR_VARREADONLY);
                                return 0;
                                
                        }
#endif                  
                        *scriptptr++=i; // the ID of the DEF (offset into array...)

                        break;
                }
                case CON_SETACTORVAR:
                case CON_GETACTORVAR:
                {
                        // syntax [gs]etactorvar[<var>].<varx> <VAR>
                        // gets the value of the per-actor variable varx into VAR
                        
                        // now get name of <var>
                        while((*textptr != '['))
                        {
                                textptr++;
                        }
                        if(*textptr == '[')
                                textptr++;
                
                        // get the ID of the DEF
                        getlabel();     //GetGameVarLabel();
//printf("found label of '%s'\n",       label+(labelcnt<<6));

                        // Check to see if it's a keyword
                        for(i=0;i<NUMKEYWORDS;i++)
                                if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                {
                                        error++;
                                        ReportError(ERROR_ISAKEYWORD);
                                        return 0;
                                }

                        i=GetDefID(label+(labelcnt<<6));
//printf("Label '%s' ID is %d\n",label+(labelcnt<<6), i);
                        if(i<0)
                        {       // not a defined DEF
                                error++;
                                ReportError(ERROR_NOTAGAMEDEF);
                                return 0;
                        }
#if 0
                        if(aGameVars[i].dwFlags & GAMEVAR_FLAG_READONLY)
                        {
                                error++;
                                ReportError(ERROR_VARREADONLY);
                                return 0;
                                
                        }
#endif                  
                        *scriptptr++=i; // the ID of the DEF (offset into array...)

                        // now get name of .<varx>
                        while(*textptr != '.')
                        {
                                if(*textptr == 0xa)
                                        break;
                                if(!*textptr)
                                        break;
                                
                                textptr++;
                        }
                        if(*textptr!='.')
                        {
                                error++;
                                printf("  * ERROR!(L%ld) Syntax error\n",line_number);
                                return 0;
                        
                        }
                        textptr++;
                        /// now pointing at 'xxx'

                        
                        // get the ID of the DEF
                        getlabel();     //GetGameVarLabel();
//printf("found label of '%s'\n",       label+(labelcnt<<6));

                        // Check to see if it's a keyword
                        for(i=0;i<NUMKEYWORDS;i++)
                                if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                {
                                        error++;
                                        ReportError(ERROR_ISAKEYWORD);
                                        return 0;
                                }

                        i=GetDefID(label+(labelcnt<<6));
//printf("Label '%s' ID is %d\n",label+(labelcnt<<6), i);
                        if(i<0)
                        {       // not a defined DEF
                                error++;
                                ReportError(ERROR_NOTAGAMEDEF);
                                return 0;
                        }
#if 1
                        if(tw == CON_SETACTORVAR && aGameVars[i].dwFlags & GAMEVAR_FLAG_READONLY)
                        {
                                error++;
                                ReportError(ERROR_VARREADONLY);
                                return 0;
                                
                        }
                        if(tw == CON_SETACTORVAR && !(aGameVars[i].dwFlags & GAMEVAR_FLAG_PERACTOR))
                        {
                                error++;
                                printf("  * ERROR!(L%ld) Variable '%s' is not per-actor.\n",line_number,label+(labelcnt<<6));
                                return 0;
                                
                        }
#endif                  
                        *scriptptr++=i; // the ID of the DEF (offset into array...)

                        // get the ID of the DEF
                        getlabel();     //GetGameVarLabel();
//printf("found label of '%s'\n",       label+(labelcnt<<6));

                        // Check to see if it's a keyword
                        for(i=0;i<NUMKEYWORDS;i++)
                                if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                {
                                        error++;
                                        ReportError(ERROR_ISAKEYWORD);
                                        return 0;
                                }

                        i=GetDefID(label+(labelcnt<<6));
//printf("Label '%s' ID is %d\n",label+(labelcnt<<6), i);
                        if(i<0)
                        {       // not a defined DEF
                                error++;
                                ReportError(ERROR_NOTAGAMEDEF);
                                return 0;
                        }
#if 1
                        if(tw == CON_GETACTORVAR && aGameVars[i].dwFlags & GAMEVAR_FLAG_READONLY)
                        {
                                error++;
                                ReportError(ERROR_VARREADONLY);
                                return 0;
                                
                        }
#endif                  
                        *scriptptr++=i; // the ID of the DEF (offset into array...)

                        break;
                }
                case CON_SETACTOR:
                case CON_GETACTOR:
                {
                        long lLabelID;
                        // syntax getsector[<var>].x <VAR>
                        // gets the value of sector[<var>].xxx into <VAR>
                        
                        // now get name of .xxx
                        while((*textptr != '['))
                        {
                                textptr++;
                        }
                        if(*textptr == '[')
                                textptr++;
                
                        // get the ID of the DEF
                        getlabel();     //GetGameVarLabel();
//printf("found label of '%s'\n",       label+(labelcnt<<6));

                        // Check to see if it's a keyword
                        for(i=0;i<NUMKEYWORDS;i++)
                                if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                {
                                        error++;
                                        ReportError(ERROR_ISAKEYWORD);
                                        return 0;
                                }

                        i=GetDefID(label+(labelcnt<<6));
//printf("Label '%s' ID is %d\n",label+(labelcnt<<6), i);
                        if(i<0)
                        {       // not a defined DEF
                                error++;
                                ReportError(ERROR_NOTAGAMEDEF);
                                return 0;
                        }
#if 0
                        if(aGameVars[i].dwFlags & GAMEVAR_FLAG_READONLY)
                        {
                                error++;
                                ReportError(ERROR_VARREADONLY);
                                return 0;
                                
                        }
#endif                  
                        *scriptptr++=i; // the ID of the DEF (offset into array...)

                        // now get name of .xxx
                        while(*textptr != '.')
                        {
                                if(*textptr == 0xa)
                                        break;
                                if(!*textptr)
                                        break;
                                
                                textptr++;
                        }
                        if(*textptr!='.')
                        {
                                error++;
                                printf("  * ERROR!(L%ld) Syntax error\n",line_number);
                                return 0;
                        
                        }
                        textptr++;
                        /// now pointing at 'xxx'
                        getlabel();
//printf("found xxx label of '%s'\n",   label+(labelcnt<<6));

                        lLabelID=getlabeloffset(actorlabels,label+(labelcnt<<6));
                        if(lLabelID == -1 )
                        {
                                error++;
                                ReportError(ERROR_SYMBOLNOTRECOGNIZED);
                                return 0;
                        }
                        *scriptptr++=actorlabels[lLabelID].lId;

                        if (actorlabels[lLabelID].flags & LABEL_HASPARM2)
                        {
                                // get parm2
                        // get the ID of the DEF
                                getlabel();     //GetGameVarLabel();
//printf("found label of '%s'\n",       label+(labelcnt<<6));

                        // Check to see if it's a keyword
                                for(i=0;i<NUMKEYWORDS;i++)
                                        if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                        {
                                                error++;
                                                ReportError(ERROR_ISAKEYWORD);
                                                return 0;
                                        }

                                i=GetDefID(label+(labelcnt<<6));
//printf("Label '%s' ID is %d\n",label+(labelcnt<<6), i);
                                if(i<0)
                                {       // not a defined DEF
                                        error++;
                                        ReportError(ERROR_NOTAGAMEDEF);
                                        printf("  * ERROR!(L%ld) Symbol '%s' is not a Game Definition.\n",line_number,label+(labelcnt<<6));
                                        return 0;
                                }
                                *scriptptr++=i; // the ID of the DEF (offset into array...)
                        }

                        // now at target VAR...
                        
                        // get the ID of the DEF
                        getlabel();     //GetGameVarLabel();
//printf("found label of '%s'\n",       label+(labelcnt<<6));

                        // Check to see if it's a keyword
                        for(i=0;i<NUMKEYWORDS;i++)
                                if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                {
                                        error++;
                                        ReportError(ERROR_ISAKEYWORD);
                                        return 0;
                                }

                        i=GetDefID(label+(labelcnt<<6));
//printf("Label '%s' ID is %d\n",label+(labelcnt<<6), i);
                        if(i<0)
                        {       // not a defined DEF
                                error++;
                                ReportError(ERROR_NOTAGAMEDEF);
                                return 0;
                        }
#if 1
                        if(tw == CON_GETACTOR && aGameVars[i].dwFlags & GAMEVAR_FLAG_READONLY)
                        {
                                error++;
                                ReportError(ERROR_VARREADONLY);
                                return 0;
                                
                        }
#endif                  
                        *scriptptr++=i; // the ID of the DEF (offset into array...)

                        break;
                }
                case CON_ESPAWNVAR:
                        // syntax: espawnvar <Var1>
                        // spawns the sprite of type ID and sets RETURN to spawned sprite ID
                        // FALL THROUGH:
                case CON_LOCKPLAYER:
                        // syntax: lockplayer   <var1>
                        // sets locks the player controls for <var1> ticks
                        
//printf("Found lockplayer at line= %ld\n",line_number);

                        // get the ID of the DEF
                        getlabel();     //GetGameVarLabel();
//printf("found label of '%s'\n",       label+(labelcnt<<6));

                        // Check to see if it's a keyword
                        for(i=0;i<NUMKEYWORDS;i++)
                                if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                {
                                        error++;
                                        ReportError(ERROR_ISAKEYWORD);
                                        return 0;
                                }

                        i=GetDefID(label+(labelcnt<<6));
//printf("Label '%s' ID is %d\n",label+(labelcnt<<6), i);
                        if(i<0)
                        {       // not a defined DEF
                                error++;
                                ReportError(ERROR_NOTAGAMEDEF);
                                return 0;
                        }
                        if(aGameVars[i].dwFlags & GAMEVAR_FLAG_READONLY)
                        {
                                error++;
                                ReportError(ERROR_VARREADONLY);
                                return 0;
                                
                        }
                        *scriptptr++=i; // the ID of the DEF (offset into array...)
        
                        return 0;
#endif
#ifdef EDUKE
                case CON_ENHANCED:
                {
                        long k;
                        // we are enhanced, baby...
                        if(g_bEnhanced)
                        {
                                printf("  * ERROR!(L%ld) Multiple 'enhanced' commands.  There can be only one..\n",line_number);
                                error++;
                        }
//                      g_bEnhanced=1;

                        // don't store in pCode...
                        scriptptr--;
//printf("We are enhanced, baby...\n");                 
                        transnum();
                        k = *(scriptptr-1);
                        g_bEnhanced=k;
                        scriptptr--;
                        if(k > VERSIONCHECK)
                        {
                                printf("  * ERROR:      This CON Code requires at least Build %ld, but we are only Build %ld\n",k,(long)VERSIONCHECK);
                                error++;
                        }
                        break;
                }
#endif                  
#ifdef WW2
                case CON_SETVAR:
                case CON_ADDVAR:
#ifdef EDUKE
                case CON_SUBVAR:
                case CON_RANDVAR:
                case CON_MULVAR:
                case CON_DIVVAR:
                case CON_MODVAR:
                case CON_ANDVAR:
                case CON_ORVAR:
                case CON_XORVAR:
#endif
                        // syntax: [rand|add|set]var    <var1> <const1>
                        // sets var1 to const1
                        // adds const1 to var1 (const1 can be negative...)
//printf("Found [add|set]var at line= %ld\n",line_number);

                        // get the ID of the DEF
                        getlabel();     //GetGameVarLabel();
//printf("found label of '%s'\n",       label+(labelcnt<<6));

                        // Check to see if it's a keyword
                        for(i=0;i<NUMKEYWORDS;i++)
                                if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                {
                                        error++;
                                        ReportError(ERROR_ISAKEYWORD);
                                        return 0;
                                }

                        i=GetDefID(label+(labelcnt<<6));
//printf("Label '%s' ID is %d\n",label+(labelcnt<<6), i);
                        if(i<0)
                        {       // not a defined DEF
                                error++;
                                ReportError(ERROR_NOTAGAMEDEF);
                                return 0;
                        }
                        if(aGameVars[i].dwFlags & GAMEVAR_FLAG_READONLY)
                        {
                                error++;
                                ReportError(ERROR_VARREADONLY);
                                return 0;
                                
                        }
                        *scriptptr++=i; // the ID of the DEF (offset into array...)
                        
                        transnum();     // the number to check against...
                        return 0;

                case CON_SETVARVAR:
                case CON_ADDVARVAR:
#ifdef EDUKE
                case CON_SUBVARVAR:
                case CON_MULVARVAR:
                case CON_DIVVARVAR:
                case CON_MODVARVAR:
                case CON_ANDVARVAR:
                case CON_ORVARVAR:
                case CON_XORVARVAR:
                case CON_RANDVARVAR:
                case CON_SIN:
                case CON_GMAXAMMO:
                case CON_SMAXAMMO:
#endif
                        // syntax: [add|set]varvar <var1> <var2>
                        // sets var1 = var2
                        // adds var1 and var2 with result in var1
//printf("Found [set|addd]varvar at line= %ld\n",line_number);

                        // get the ID of the DEF
                        getlabel();     //GetGameVarLabel();
//printf("found label1 of '%s'\n",      label+(labelcnt<<6));

                        // Check to see if it's a keyword
                        for(i=0;i<NUMKEYWORDS;i++)
                                if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                {
                                        error++;
                                        ReportError(ERROR_ISAKEYWORD);
                                        return 0;
                                }

                        i=GetDefID(label+(labelcnt<<6));
//printf("Label '%s' ID is %d\n",label+(labelcnt<<6), i);
                        if(i<0)
                        {       // not a defined DEF
                                error++;
                                ReportError(ERROR_NOTAGAMEDEF);
                                return 0;
                        }
                        if(aGameVars[i].dwFlags & GAMEVAR_FLAG_READONLY)
                        {
                                error++;
                                ReportError(ERROR_VARREADONLY);
                                return 0;
                                
                        }
                        *scriptptr++=i; // the ID of the DEF (offset into array...)
                        
                        // get the ID of the DEF
                        getlabel();     //GetGameVarLabel();
//printf("found label2 of '%s'\n",      label+(labelcnt<<6));

                        // Check to see if it's a keyword
                        for(i=0;i<NUMKEYWORDS;i++)
                                if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                {
                                        error++;
                                        ReportError(ERROR_ISAKEYWORD);
                                        return 0;
                                }

                        i=GetDefID(label+(labelcnt<<6));
//printf("Label '%s' ID is %d\n",label+(labelcnt<<6), i);
                        if(i<0)
                        {       // not a defined DEF
                                error++;
                                ReportError(ERROR_NOTAGAMEDEF);
                                return 0;
                        }
#ifndef EDUKE
// this was a bug:      second var can be RO because it is source
                        if(aGameVars[i].dwFlags & GAMEVAR_FLAG_READONLY)
                        {
                                error++;
                                ReportError(ERROR_VARREADONLY);
                                return 0;
                                
                        }
#endif                  
                        *scriptptr++=i; // the ID of the DEF (offset into array...)
                        return 0;
                        
                case CON_IFVARVARG:
                case CON_IFVARVARL:
                case CON_IFVARVARE:
                case CON_IFVARVARN:
                case CON_IFVARVARAND:

                        // get the ID of the DEF
                        getlabel();     //GetGameVarLabel();
                        // Check to see it's a keyword

                        for(i=0;i<NUMKEYWORDS;i++)
                                if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                {
                                        error++;
                                        ReportError(ERROR_ISAKEYWORD);
                                        return 0;
                                }

                        i=GetDefID(label+(labelcnt<<6));
                        if(i<0)
                        {       // not a defined DEF
                                error++;
                                ReportError(ERROR_NOTAGAMEDEF);
                                return 0;
                        }
                        *scriptptr++=i; // the ID of the DEF (offset into array...)
                        
                        // get the ID of the DEF
                        getlabel();     //GetGameVarLabel();
                        // Check to see it's a keyword

                        for(i=0;i<NUMKEYWORDS;i++)
                                if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                {
                                        error++;
                                        ReportError(ERROR_ISAKEYWORD);
                                        return 0;
                                }
                        
                        i=GetDefID(label+(labelcnt<<6));
//printf("Label '%s' ID is %d\n",label+(labelcnt<<6), i);
                        if(i<0)
                        {       // not a defined DEF
                                error++;
                                ReportError(ERROR_NOTAGAMEDEF);
                                return 0;
                        }
                        *scriptptr++=i; // the ID of the DEF (offset into array...)
                
                        tempscrptr = scriptptr;
                        scriptptr++; //Leave a spot for the fail location

                        // eat comments
                        do
                        {
                                j = keyword();
                                if(j == 20 || j == 39)
                                        parsecommand();
                        } while(j == 20 || j == 39);

                        parsecommand();

                        *tempscrptr = (long) scriptptr;

                        checking_ifelse++;
                        return 0;
                case CON_SPGETLOTAG:
                case CON_SPGETHITAG:
                case CON_SECTGETLOTAG:
                case CON_SECTGETHITAG:
                case CON_GETTEXTUREFLOOR:
                case CON_GETTEXTURECEILING:
                        // no paramaters...
                        return 0;
                case CON_STARTTRACK:
                        // one parameter (track#)
                        transnum();
                        return 0;
                case CON_GETTEXTUREWALL:
                        error++;
                        printf("  * ERROR!(L%ld) Command  '%s' is not yet implemented.\n",line_number,tempbuf);
                        return 0;
                case CON_DISPLAYRAND:
                        // syntax: displayrand <var>
                        // gets rand (not game rand) into <var>
                        
                        // Get The ID of the DEF
                        getlabel();     //GetGameVarLabel();
                        // Check to see it's a keyword

                        for(i=0;i<NUMKEYWORDS;i++)
                                if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                {
                                        error++;
                                        ReportError(ERROR_ISAKEYWORD);
                                        return 0;
                                }
                        
                        i=GetDefID(label+(labelcnt<<6));
//printf("Label '%s' ID is %d\n",label+(labelcnt<<6), i);
                        if(i<0)
                        {       // not a defined DEF
                                error++;
                                ReportError(ERROR_NOTAGAMEDEF);
                                return 0;
                        }
                        *scriptptr++=i; // the ID of the DEF (offset into array...)
                        break;
                case CON_SWITCH:
//AddLog("Got Switch statement");
if(checking_switch)
{
//      sprintf(g_szBuf,"ERROR::%s %d: Checking_switch=",__FILE__,__LINE__, checking_switch);
//      AddLog(g_szBuf);
}
                        checking_switch++; // allow nesting (if other things work)
                        // Get The ID of the DEF
                        getlabel();     //GetGameVarLabel();
                        // Check to see it's a keyword

                        for(i=0;i<NUMKEYWORDS;i++)
                                if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                {
                                        ReportError(ERROR_ISAKEYWORD);
                                        error++;
                                        return 0;
                                }
                        
                        i=GetDefID(label+(labelcnt<<6));
//sprintf(g_szBuf,"Variable '%s' ID is %d\n",label+(labelcnt<<6), i);
//AddLog(g_szBuf);
                        if(i<0)
                        {       // not a defined DEF
                                error++;
                                ReportError(ERROR_NOTAGAMEVAR);
                                return 0;
                        }
                        *scriptptr++=i; // the ID of the DEF (offset into array...)
                        
                        tempscrptr= scriptptr;
                        *scriptptr++=0; // leave spot for end location (for after processing)
                        *scriptptr++=0; // count of case statements
                        casescriptptr=scriptptr;        // the first case's pointer.
                
                        *scriptptr++=0; // leave spot for 'default' location (null if none)

                        j = keyword();
                        while (j==20)   // '//'
                        {
                                while(*textptr != 0x0a)
                                        textptr++;
                                
                                j=keyword();
                        }
                        temptextptr=textptr;
                        // probably does not allow nesting...

//AddLog("Counting Case Statements...");
                        
                        j=CountCaseStatements();
//sprintf(g_szBuf,"Done Counting Case Statements: found %d.", j);
//AddLog(g_szBuf);
if(checking_switch>1)
{
//      sprintf(g_szBuf,"ERROR::%s %d: Checking_switch=",__FILE__,__LINE__, checking_switch);
//      AddLog(g_szBuf);
}
                        if( j<0 )
                        {
                                return 1;
                        }
                        if (tempscrptr)
                        {
                                tempscrptr[1]=(long)j;  // save count of cases
                        }
                        else
                        {
//sprintf(g_szBuf,"ERROR::%s %d",__FILE__,__LINE__);
//AddLog(g_szBuf);
                        }
                        
                        while(j--)
                        {
                                 // leave room for statements
                                *scriptptr++=0; // value check
                                *scriptptr++=0; // code offset
                        }
                        
//sprintf(g_szBuf,"SWITCH1: '%.22s'",textptr);
//AddLog(g_szBuf);
                        
                        casecount=0;
                        while ( parsecommand() == 0 )
                        {
//sprintf(g_szBuf,"SWITCH2: '%.22s'",textptr);
//AddLog(g_szBuf);
                        }
//sprintf(g_szBuf,"SWITCHXX: '%.22s'",textptr);
//AddLog(g_szBuf);
                        // done processing switch.  clean up.
if(checking_switch!=1)
{
//      sprintf(g_szBuf,"ERROR::%s %d: Checking_switch=%d",__FILE__,__LINE__, checking_switch);
//      AddLog(g_szBuf);
}
                        casecount=0;
                        if (tempscrptr)
                        {
                                tempscrptr[0]= (long)scriptptr - (long)&script[0];      // save 'end' location
                        }
                        else
                        {
//sprintf(g_szBuf,"ERROR::%s %d",__FILE__,__LINE__);
//AddLog(g_szBuf);
                        }
                        casescriptptr=NULL;
// decremented in endswitch.  Don't decrement here...
//                      checking_switch--; // allow nesting (maybe if other things work)
                        tempscrptr=NULL;
                        if(checking_switch)
                        {
//sprintf(g_szBuf,"ERROR::%s %d: Checking_switch=%d",__FILE__,__LINE__, checking_switch);
//AddLog(g_szBuf);
                        }
//AddLog("End of Switch statement");
                        break;

                        
                case CON_CASE:
//AddLog("Found Case");
repeatcase:
                        scriptptr--; // don't save in code
                        if(checking_switch<1)
                        {
                                error++;
                                printf("  * ERROR!(L%ld) case statement when not in switch\n",line_number);
                                return 1;
                        }
                        casecount++;
//sprintf(g_szBuf,"case1: %.12s",textptr);
//AddLog(g_szBuf);
                        transnum();
//sprintf(g_szBuf,"case2: %.12s",textptr);
//AddLog(g_szBuf);

                        j=*(--scriptptr);       // get value
//sprintf(g_szBuf,"case: Value of case %ld is %ld",(long)casecount,(long)j);
//AddLog(g_szBuf);
                        if( casescriptptr)
                        {
//AddLog("Adding value to script");                             
                                casescriptptr[casecount++]=j;   // save value
                                casescriptptr[casecount]=(long)((long*)scriptptr-&script[0]);   // save offset
                        }
                        j = keyword();
//sprintf(g_szBuf,"case3: %.12s",textptr);
//AddLog(g_szBuf);
                        while (j==20)   // '//'
                        {
                                while(*textptr != 0x0a)
                                        textptr++;
                                
                                j=keyword();
                        }
                        if (j == CON_CASE)
                        {
//AddLog("Found Repeat Case");
                                transword();    // eat 'case'
                                goto repeatcase;
                        }
//sprintf(g_szBuf,"case4: '%.12s'",textptr);
//AddLog(g_szBuf);
                        while(parsecommand() == 0)
                        {
//sprintf(g_szBuf,"case5 '%.25s'",textptr);
//AddLog(g_szBuf);
                                ;
                        }
//AddLog("End Case");
                        return 0;
                        break;
                case CON_DEFAULT:
                        scriptptr--;    // don't save
                        if(casescriptptr && casescriptptr[0]!=0)
                        {
                                // duplicate default statement
                                error++;
                                printf("  * ERROR!(L%ld) multiple default statements found in switch\n",line_number);
                        }
                        if (casescriptptr)
                        {
                                casescriptptr[0]=(long)(scriptptr-&script[0]); // save offset.
                        }
//sprintf(g_szBuf,"default: '%.22s'",textptr);
//AddLog(g_szBuf);
                        while( parsecommand() == 0)
                        {
//sprintf(g_szBuf,"defaultParse: '%.22s'",textptr);
//AddLog(g_szBuf);
                                ;
                        }
                        break;
//              case CON_BREAK:
//                      if(checking_switch<1 )
//                      {
//                              error++;
//                              printf("  * ERROR!(L%ld) break while not in switch\n",line_number);
//                      }
//                      return 1;       // end of block
//                      break;
                case CON_ENDSWITCH:
//AddLog("End Switch");
                        checking_switch--;
                        if(checking_switch < 0 )
                        {
                                error++;
                                printf("  * ERROR!(L%ld) endswitch without matching switch\n",line_number);
                        }
                        if (casescriptptr)
                        {
                                int i;

//sprintf(g_szBuf,"Default Offset is %ld\n Total of %ld cases",casescriptptr[0],(long)casecount/2);
//AddLog(g_szBuf);
                                for(i=1;i<=casecount;i++)
                                {
                                        if (i & 1)
                                        {
//sprintf(g_szBuf,"Case Value %d is %ld",i/2+1,casescriptptr[i]);
//AddLog(g_szBuf);
                                        }
                                        else
                                        {
//sprintf(g_szBuf,"Offset %d is %ld",i/2+1,casescriptptr[i]);
//AddLog(g_szBuf);
                                        }
                                }
                        }
                        else
                        {
//AddLog("Not saving case value: just counting");
                        }
                        return 1;       // end of block
                        break;
                case CON_STARTLEVEL:
                        // start at specified level
                        // startlevel <episode> <level>
                        if(!g_bEnhanced)
                        {
                                error++;
                                printf("  * ERROR!(L%ld) Command  '%s' is enhanced only.  Define enhance with the version number your code needs before using this commands.\n",line_number,tempbuf);
                                return 0;
                        }
                        // get the ID of the DEF
                        getlabel();     //GetGameVarLabel();
                        // Check to see it's a keyword

                        for(i=0;i<NUMKEYWORDS;i++)
                                if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                {
                                        error++;
                                        ReportError(ERROR_ISAKEYWORD);
                                        return 0;
                                }

                        i=GetDefID(label+(labelcnt<<6));
                        if(i<0)
                        {       // not a defined DEF
                                error++;
                                ReportError(ERROR_NOTAGAMEDEF);
                                return 0;
                        }
                        *scriptptr++=i; // the ID of the DEF (offset into array...)
                        
                        // get the ID of the DEF
                        getlabel();     //GetGameVarLabel();
                        // Check to see it's a keyword

                        for(i=0;i<NUMKEYWORDS;i++)
                                if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                {
                                        error++;
                                        ReportError(ERROR_ISAKEYWORD);
                                        return 0;
                                }

                        i=GetDefID(label+(labelcnt<<6));
                        if(i<0)
                        {       // not a defined DEF
                                error++;
                                ReportError(ERROR_NOTAGAMEDEF);
                                return 0;
                        }
                        *scriptptr++=i; // the ID of the DEF (offset into array...)
                        break;
                case CON_MAPVOXEL:
                        // map a tilenum to a voxel.
                        // syntax: mapvoxel <tilenum> <filename (8.3)>
                        if(!g_bEnhanced)
                        {
                                error++;
                                printf("  * ERROR!(L%ld) Command  '%s' is enhanced only.  Define enhance with the version number your code needs before using this commands.\n",line_number,tempbuf);
                                return 0;
                        }
                        scriptptr--; // don't save in compiled code
                        
                        transnum();
                        j=*(--scriptptr);       // get value

                        while( *textptr == ' ' || *textptr == '\t' ) textptr++;
                        
                        i=0;
                        voxel_map[j].name[i]=0;
                        voxel_map[j].voxnum=-2; // flag to load later
                        while( (i<12) && (isalnum(*textptr) || *textptr=='.') )
                        {
                                voxel_map[j].name[i++]=*textptr++;
                        }
                        voxel_map[j].name[i]=0;
                        break;
                case CON_MYOS:
                case CON_MYOSPAL:
                case CON_MYOSX:
                case CON_MYOSPALX:
                        if(!g_bEnhanced)
                        {
                                error++;
                                printf("  * ERROR!(L%ld) Command  '%s' is enhanced only.  Define enhance with the version number your code needs before using this commands.\n",line_number,tempbuf);
                                return 0;
                        }
                        // syntax:
                        // long x, long y, short tilenum, signed char shade, char orientation
                        // myospal adds char pal

                        // Parse: x
                        
                        // get the ID of the DEF
                        getlabel();     //GetGameVarLabel();
                        // Check to see it's a keyword

                        for(i=0;i<NUMKEYWORDS;i++)
                                if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                {
                                        error++;
                                        ReportError(ERROR_ISAKEYWORD);
                                        return 0;
                                }

                        i=GetDefID(label+(labelcnt<<6));
                        if(i<0)
                        {       // not a defined DEF
                                error++;
                                ReportError(ERROR_NOTAGAMEDEF);
                                return 0;
                        }
                        *scriptptr++=i; // the ID of the DEF (offset into array...)

                        // Parse: Y
                        
                        // get the ID of the DEF
                        getlabel();     //GetGameVarLabel();
                        // Check to see it's a keyword

                        for(i=0;i<NUMKEYWORDS;i++)
                                if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                {
                                        error++;
                                        ReportError(ERROR_ISAKEYWORD);
                                        return 0;
                                }

                        i=GetDefID(label+(labelcnt<<6));
                        if(i<0)
                        {       // not a defined DEF
                                error++;
                                ReportError(ERROR_NOTAGAMEVAR);
                                return 0;
                        }
                        *scriptptr++=i; // the ID of the DEF (offset into array...)

                        // Parse: tilenum
                        
                        // get the ID of the DEF
                        getlabel();     //GetGameVarLabel();
                        // Check to see it's a keyword

                        for(i=0;i<NUMKEYWORDS;i++)
                                if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                {
                                        error++;
                                        ReportError(ERROR_ISAKEYWORD);
                                        return 0;
                                }

                        i=GetDefID(label+(labelcnt<<6));
                        if(i<0)
                        {       // not a defined DEF
                                error++;
                                ReportError(ERROR_NOTAGAMEVAR);
                                return 0;
                        }
                        *scriptptr++=i; // the ID of the DEF (offset into array...)

                        // Parse: shade
                        
                        // get the ID of the DEF
                        getlabel();     //GetGameVarLabel();
                        // Check to see it's a keyword

                        for(i=0;i<NUMKEYWORDS;i++)
                                if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                {
                                        error++;
                                        ReportError(ERROR_ISAKEYWORD);
                                        return 0;
                                }

                        i=GetDefID(label+(labelcnt<<6));
                        if(i<0)
                        {       // not a defined DEF
                                error++;
                                ReportError(ERROR_NOTAGAMEVAR);
                                return 0;
                        }
                        *scriptptr++=i; // the ID of the DEF (offset into array...)

                        // Parse: orientation
                        
                        // get the ID of the DEF
                        getlabel();     //GetGameVarLabel();
                        // Check to see it's a keyword

                        for(i=0;i<NUMKEYWORDS;i++)
                                if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                {
                                        error++;
                                        ReportError(ERROR_ISAKEYWORD);
                                        return 0;
                                }

                        i=GetDefID(label+(labelcnt<<6));
                        if(i<0)
                        {       // not a defined DEF
                                error++;
                                ReportError(ERROR_NOTAGAMEVAR);
                                return 0;
                        }
                        *scriptptr++=i; // the ID of the DEF (offset into array...)

                        if(tw==CON_MYOSPAL || tw==CON_MYOSPALX)
                        {
                        // Parse: pal
                        
                        // get the ID of the DEF
                        getlabel();     //GetGameVarLabel();
                        // Check to see it's a keyword

                        for(i=0;i<NUMKEYWORDS;i++)
                                if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                {
                                        error++;
                                        ReportError(ERROR_ISAKEYWORD);
                                        return 0;
                                }

                        i=GetDefID(label+(labelcnt<<6));
                        if(i<0)
                        {       // not a defined DEF
                                error++;
                                ReportError(ERROR_NOTAGAMEVAR);
                                return 0;
                        }
                        *scriptptr++=i; // the ID of the DEF (offset into array...)
                        }
                        
                        break;
                        
                case CON_IFVARL:
                case CON_IFVARG:
                case CON_IFVARE:
                case CON_IFVARN:
                case CON_IFVARAND:

                        // get the ID of the DEF
                        getlabel();     //GetGameVarLabel();
                        // Check to see it's a keyword

                        for(i=0;i<NUMKEYWORDS;i++)
                                if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                {
                                        error++;
                                        ReportError(ERROR_ISAKEYWORD);
                                        return 0;
                                }

                        i=GetDefID(label+(labelcnt<<6));
                        if(i<0)
                        {       // not a defined DEF
                                error++;
                                ReportError(ERROR_NOTAGAMEVAR);
                                return 0;
                        }
                        *scriptptr++=i; // the ID of the DEF (offset into array...)
                        
                        transnum();     // the number to check against...
                        
                        tempscrptr = scriptptr;
                        scriptptr++; //Leave a spot for the fail location

                        do
                        {
                                j = keyword();
                                if(j == 20 || j == 39)
                                        parsecommand();
                        } while(j == 20 || j == 39);

                        parsecommand();

                        *tempscrptr = (long) scriptptr;

                        checking_ifelse++;
                        return 0;
                
                case CON_ADDLOGVAR:
                        // syntax: addlogvar <var>
                        
                        // source file.
                        *scriptptr=(long)g_currentSourceFile;
                        scriptptr++;
                        
                        // prints the line number in the log file.
                        *scriptptr=line_number;
                        scriptptr++;
                        
                        // get the ID of the DEF
                        getlabel();     //GetGameVarLabel();
//printf("found label of '%s'\n",       label+(labelcnt<<6));

                        // Check to see if it's a keyword
                        for(i=0;i<NUMKEYWORDS;i++)
                                if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                {
                                        error++;
                                        ReportError(ERROR_ISAKEYWORD);
                                        return 0;
                                }

                        i=GetDefID(label+(labelcnt<<6));
//printf("Label '%s' ID is %d\n",label+(labelcnt<<6), i);
                        if(i<0)
                        {       // not a defined DEF
                                error++;
                                ReportError(ERROR_NOTAGAMEDEF);
                                return 0;
                        }
                        *scriptptr++=i; // the ID of the DEF (offset into array...)
                        
                        return 0;
                case CON_GETANGLETOTARGET:
                case CON_GETACTORANGLE:
                case CON_SETACTORANGLE:
                case CON_GETPLAYERANGLE:
                case CON_SETPLAYERANGLE:
                        // Syntax:       <command> <var>
                        
                        // get the ID of the DEF
                        getlabel();     //GetGameVarLabel();
//printf("found label of '%s'\n",       label+(labelcnt<<6));

                        // Check to see if it's a keyword
                        for(i=0;i<NUMKEYWORDS;i++)
                                if( strcmp( label+(labelcnt<<6),keyw[i]) == 0 )
                                {
                                        error++;
                                        ReportError(ERROR_ISAKEYWORD);
                                        return 0;
                                }

                        i=GetDefID(label+(labelcnt<<6));
//printf("Label '%s' ID is %d\n",label+(labelcnt<<6), i);
                        if(i<0)
                        {       // not a defined DEF
                                error++;
                                ReportError(ERROR_NOTAGAMEDEF);
                                return 0;
                        }
                        *scriptptr++=i; // the ID of the DEF (offset into array...)
                        
                        return 0;
                        
                case CON_ADDLOG:
                        // syntax: addlog

                        // source file.
                        *scriptptr=(long)g_currentSourceFile;
                        scriptptr++;
                        
                        // prints the line number in the log file.
                        *scriptptr=line_number;
                        scriptptr++;
                        return 0;
                        
#endif

                case 75:
                        transnum();
                case 3:
                case 8:
                case 9:
                case 21:
                case 33:
                case 34:
                case 35:
                case 41:
                case 46:
                case 53:
                case 56:
                case 59:
                case 62:
                case 72:
                case 73:
//                case 74:
                case 78:
                case 85:
                case 94:
                case 111:
                        transnum();
                case 43:
                case 44:
                case 49:
                case 5:
                case 6:
                case 27:
                case 26:
                case 45:
                case 51:
                case 63:
                case 64:
                case 65:
                case 67:
                case 70:
                case 71:
                case 81:
                case 82:
                case 90:
                case 91:
                case 109:

                        if(tw == 51)
                        {
                                j = 0;
                                do
                                {
                                        transnum();
                                        scriptptr--;
                                        j |= *scriptptr;
                                }
                                while(keyword() == -1);
                                *scriptptr = j;
                                scriptptr++;
                        }

                        tempscrptr = scriptptr;
                        scriptptr++; //Leave a spot for the fail location

                        do
                        {
                                j = keyword();
                                if(j == 20 || j == 39)
                                        parsecommand();
                        } while(j == 20 || j == 39);

                        parsecommand();

                        *tempscrptr = (long) scriptptr;

                        checking_ifelse++;
                        return 0;
                case 29:
                        num_squigilly_brackets++;
                        do
                                done = parsecommand();
                        while( done == 0 );
                        return 0;
                case 30:
                        num_squigilly_brackets--;
                        if( num_squigilly_brackets < 0 )
                        {
                                if(checking_switch)
                                {
                                        ReportError(ERROR_NOENDSWITCH);
                                }
                                printf("  * ERROR!(L%ld) Found more '}' than '{'.\n",line_number);
                                error++;
                        }
                        return 1;
                case 76:
                        scriptptr--;
                        j = 0;
                        while( *textptr != 0x0a )
                        {
                                betaname[j] = *textptr;
                                j++; textptr++;
                        }
                        betaname[j] = 0;
                        return 0;
                case 20:
                        scriptptr--; //Negate the rem
                        while( *textptr != 0x0a )
                                textptr++;

                        // line_number++;
                        return 0;

                case 107:
                        scriptptr--;
                        transnum();
                        scriptptr--;
                        j = *scriptptr;
#ifdef EDUKE                    
                        while( *textptr == ' ' ) textptr++;
#else
                        while( *textptr == ' ' || *textptr== '\t' ) textptr++;
#endif

                        i = 0;

                        while( *textptr != 0x0a )
                        {
                                volume_names[j][i] = toupper(*textptr);
                                textptr++,i++;
                                if(i >= 32)
                                {
                                        printf("  * ERROR!(L%ld) Volume name exceeds character size limit of 32.\n",line_number);
                                        error++;
                                        while( *textptr != 0x0a ) textptr++;
                                        break;
                                }
                        }
                        volume_names[j][i-1] = '\0';
                        return 0;
                case 108:
                        scriptptr--;
                        transnum();
                        scriptptr--;
                        j = *scriptptr;
                        while( *textptr == ' ' ) textptr++;

                        i = 0;

                        while( *textptr != 0x0a )
                        {
                                skill_names[j][i] = toupper(*textptr);
                                textptr++,i++;
                                if(i >= 32)
                                {
                                        printf("  * ERROR!(L%ld) Skill name exceeds character size limit of 32.\n",line_number);
                                        error++;
                                        while( *textptr != 0x0a ) textptr++;
                                        break;
                                }
                        }
                        skill_names[j][i-1] = '\0';
                        return 0;

                case 0:
                        scriptptr--;
                        transnum();
                        scriptptr--;
                        j = *scriptptr;
                        transnum();
                        scriptptr--;
                        k = *scriptptr;
                        while( *textptr == ' ' ) textptr++;

                        i = 0;
                        while( *textptr != ' ' && *textptr != 0x0a )
                        {
                                level_file_names[j*11+k][i] = *textptr;
                                textptr++,i++;
                                if(i > 127)
                                {
                                        printf("  * ERROR!(L%ld) Level file name exceeds character size limit of 128.\n",line_number);
                                        error++;
                                        while( *textptr != ' ') textptr++;
                                        break;
                                }
                        }
                        level_names[j*11+k][i-1] = '\0';

                        while( *textptr == ' ' ) textptr++;

                        partime[j*11+k] =
                                (((*(textptr+0)-'0')*10+(*(textptr+1)-'0'))*26*60)+
                                (((*(textptr+3)-'0')*10+(*(textptr+4)-'0'))*26);

                        textptr += 5;
                        while( *textptr == ' ' ) textptr++;

                        designertime[j*11+k] =
                                (((*(textptr+0)-'0')*10+(*(textptr+1)-'0'))*26*60)+
                                (((*(textptr+3)-'0')*10+(*(textptr+4)-'0'))*26);

                        textptr += 5;
                        while( *textptr == ' ' ) textptr++;

                        i = 0;

                        while( *textptr != 0x0a )
                        {
                                level_names[j*11+k][i] = toupper(*textptr);
                                textptr++,i++;
                                if(i >= 32)
                                {
                                        printf("  * ERROR!(L%ld) Level name exceeds character size limit of 32.\n",line_number);
                                        error++;
                                        while( *textptr != 0x0a ) textptr++;
                                        break;
                                }
                        }
                        level_names[j*11+k][i-1] = '\0';
                        return 0;

                case 79:
                        scriptptr--;
                        transnum();
                        k = *(scriptptr-1);
                        if(k >= NUMOFFIRSTTIMEACTIVE)
                        {
                                printf("  * ERROR!(L%ld) Quote amount exceeds limit of %ld characters.\n",line_number,NUMOFFIRSTTIMEACTIVE);
                                error++;
                        }
                        scriptptr--;
                        i = 0;
                        while( *textptr == ' ' )
                                textptr++;

                        while( *textptr != 0x0a )
                        {
                                fta_quotes[k][i] = *textptr;
                                textptr++,i++;
                                if(i >= 64)
                                {
                                        printf("  * ERROR!(L%ld) Quote exceeds character size limit of 64.\n",line_number);
                                        error++;
                                        while( *textptr != 0x0a ) textptr++;
                                        break;
                                }
                        }
                        fta_quotes[k][i] = '\0';
                        return 0;
                case 57:
                        scriptptr--;
                        transnum();
                        k = *(scriptptr-1);
                        if(k >= NUM_SOUNDS)
                        {
                                printf("  * ERROR!(L%ld) Exceeded sound limit of %ld.\n",line_number,NUM_SOUNDS);
                                error++;
                        }
                        scriptptr--;
                        i = 0;
                        while( *textptr == ' ')
                                textptr++;

                        while( *textptr != ' ' )
                        {
                                sounds[k][i] = *textptr;
                                textptr++,i++;
                                if(i >= 13)
                                {
                                        puts(sounds[k]);
                                        printf("  * ERROR!(L%ld) Sound filename exceeded limit of 13 characters.\n",line_number);
                                        error++;
                                        while( *textptr != ' ' ) textptr++;
                                        break;
                                }
                        }
                        sounds[k][i] = '\0';

                        transnum();
                        soundps[k] = *(scriptptr-1);
                        scriptptr--;
                        transnum();
                        soundpe[k] = *(scriptptr-1);
                        scriptptr--;
                        transnum();
                        soundpr[k] = *(scriptptr-1);
                        scriptptr--;
                        transnum();
                        soundm[k] = *(scriptptr-1);
                        scriptptr--;
                        transnum();
                        soundvo[k] = *(scriptptr-1);
                        scriptptr--;
                        return 0;
                
#ifdef WW2
                        case CON_ENDEVENT:
                        if( parsing_event == 0)
                        {
                                printf("  * ERROR!(L%ld) Found 'endevent' without defining 'onevent'.\n",line_number);
                                error++;
                        }
//                        else
                        {
                                if( num_squigilly_brackets > 0 )
                                {
                                        printf("  * ERROR!(L%ld) Found more '{' than '}' before 'endevent'.\n",line_number);
                                        error++;
                                }
                                parsing_event = 0;
                                parsing_actor = 0;
                        }

                        return 0;
#endif                  
                        case 4:
                        if( parsing_actor == 0 )
                        {
                                printf("  * ERROR!(L%ld) Found 'enda' without defining 'actor'.\n",line_number);
                                error++;
                        }
//                        else
                        {
                                if( num_squigilly_brackets > 0 )
                                {
                                        printf("  * ERROR!(L%ld) Found more '{' than '}' before 'enda'.\n",line_number);
                                        error++;
                                }
                                parsing_actor = 0;
                        }

                        return 0;
                case 12:
#ifdef EDUKE
                        if(checking_switch)
                        {
//sprintf(g_szBuf,"  * (L%ld) case Break statement.\n",line_number);
//AddLog(g_szBuf);
                                return 1;
                        }
#endif
                case 16:
                case 84:
//                case 21:
                case 22:        //KILLIT
                case 36:
                case 38:
                case 42:
                case 47:
                case 61:
                case 66:
                case 83:
                case 95:
                case 96:
                case 97:
                case 104:
                case 106:
                        return 0;
                case 60:
                        j = 0;
                        while(j < 30)
                        {
                                transnum();
                                scriptptr--;

                                switch(j)
                                {
                                        case 0:
                                                ud.const_visibility = *scriptptr;
                                                break;
                                        case 1:
                                                impact_damage = *scriptptr;
                                                break;
                                        case 2:
                                                max_player_health = *scriptptr;
                                                break;
                                        case 3:
                                                max_armour_amount = *scriptptr;
                                                break;
                                        case 4:
                                                respawnactortime = *scriptptr;break;
                                        case 5:
                                                respawnitemtime = *scriptptr;break;
                                        case 6:
                                                dukefriction = *scriptptr;break;
                                        case 7:
                                                gc = *scriptptr;break;
                                        case 8:rpgblastradius = *scriptptr;break;
                                        case 9:pipebombblastradius = *scriptptr;break;
                                        case 10:shrinkerblastradius = *scriptptr; break;
                                        case 11:tripbombblastradius = *scriptptr; break;
                                        case 12:morterblastradius = *scriptptr;break;
                                        case 13:bouncemineblastradius = *scriptptr;break;
                                        case 14:seenineblastradius = *scriptptr;break;

                                        case 15:
                                        case 16:
                                        case 17:
                                        case 18:
                                        case 19:
                                        case 20:
                                        case 21:
                                        case 22:
                                        case 23:
                                        case 24:
                                                if(j == 24)
                                                        max_ammo_amount[11] = *scriptptr;
                                                else max_ammo_amount[j-14] = *scriptptr;
                                                break;
                                        case 25:
                                                camerashitable = *scriptptr;
                                                break;
                                        case 26:
                                                numfreezebounces = *scriptptr;
                                                break;
                                        case 27:
                                                freezerhurtowner = *scriptptr;
                                                break;
                                        case 28:
                                                spriteqamount = *scriptptr;
                                                if(spriteqamount > 1024) spriteqamount = 1024;
                                                else if(spriteqamount < 0) spriteqamount = 0;
                                                break;
                                        case 29:
                                                lasermode = *scriptptr;
                                                break;
                                }
                                j++;
                        }
                        scriptptr++;
                        return 0;
        }
        return 0;
}


void passone(void)
{
#ifdef WW2
#ifdef DEBUG    
        int i;
#endif
#endif

        while( parsecommand() == 0 );

        if( (error+warning) > 12)
                puts(  "  * ERROR! Too many warnings or errors.");

#ifdef WW2
#ifdef DEBUG
        printf("Game Definitions\n");
        for(i=0;i<iGameVarCount;i++)
        {
                printf("%20s\t%d\n",apszGameVarLabel[i],lGameVarValue[i]);
        }
#endif
#endif
}


#ifdef WW2
#ifdef EDUKE
// 2.1 and above
#define NUM_DEFAULT_CONS        6
char *defaultcons[NUM_DEFAULT_CONS] =
{
        {"eduke.mhs"},
        {"eduke.CON"},
        {"XUSER.CON"},
        {"XDEFS.CON"},
        {"dukewep.CON"},
        {"ENHANCE.CON"}
};
#else
#define NUM_DEFAULT_CONS        4
char *defaultcons[NUM_DEFAULT_CONS] =
{
         {"GAME.CON"},
         {"XUSER.CON"},
         {"XDEFS.CON"},
         {"ENHANCE.CON"}
};
#endif // eduke
#else
#define NUM_DEFAULT_CONS        3
char *defaultcons[NUM_DEFAULT_CONS] =
{
         {"GAME.CON"},
         {"USER.CON"},
         {"DEFS.CON"}
};

#endif

void copydefaultcons(void)
{
        long i, fs, fpi;
        FILE *fpo;
        for(i=0;i<NUM_DEFAULT_CONS;i++)
        {
                fpi = kopen4load( defaultcons[i] , 1 );
                fpo = fopen( defaultcons[i],"wb");

                if(fpi == 0)
                {
                        if(fpo == NULL) fclose(fpo);
                        continue;
                }
                if(fpo == NULL)
                {
                        if(fpi == 0) kclose(fpi);
                        continue;
                }

                fs = kfilelength(fpi);

                kread(fpi,&hittype[0],fs);
                fwrite(&hittype[0],fs,1,fpo);

                kclose(fpi);
                fclose(fpo);
        }
}

#ifdef NAM


        
void InitGameVars(void)
{
        // only call ONCE

printf("Initializing Game Variables\n");
//AddLog("InitGameVars");

        ClearGameVars();

        AddSystemVars();

        InitGameVarPointers();

        ResetSystemDefaults();
//sprintf(g_szBuf,"CP:%s %d",__FILE__,__LINE__);
//AddLog(g_szBuf);
        
}


#endif


void loadefs(char *filenam,char *mptr)
{
        int i;
        long fs,fp;
#ifdef EDUKE
        char bCompile;
        long lMagic;
        char basename[_MAX_PATH];
#endif

#ifdef WW2      
        ClearGameEvents();
        
        InitGameVars();
#endif

        if(!SafeFileExists(filenam) && loadfromgrouponly == 0)
        {
                puts("Missing external con file(s).");
                puts("COPY INTERNAL DEFAULTS TO DIRECTORY(Y/n)?");

                KB_FlushKeyboardQueue();
                while( KB_KeyWaiting() );

                i = KB_Getch();
                if(i == 'y' || i == 'Y' )
                {
                        puts(" Yes");
                        copydefaultcons();
                }
        }

//sprintf(g_szBuf,"CP:%s %d",__FILE__,__LINE__);
//AddLog(g_szBuf);
        fp = kopen4load(filenam,loadfromgrouponly);
        if( fp == 0 )
        {
//sprintf(g_szBuf,"CP:%s %d",__FILE__,__LINE__);
//AddLog(g_szBuf);
                if( loadfromgrouponly == 1 )
                {
//sprintf(g_szBuf,"CP:%s %d",__FILE__,__LINE__);
//AddLog(g_szBuf);
                        gameexit("\nMissing con file(s).");
                }

                loadfromgrouponly = 1;
                return; //Not there
        }
        else
        {
#ifdef EDUKE
                bCompile=1;
                kread(fp,&lMagic,sizeof(long));
                switch(lMagic)
                {
                        case COMPMAGIC:
                                bCompile=0;
                                break;
                        case 1234:      // old magic
                                kclose(fp);
                                ShutDown();
                                printf("\nOld Compiled format is no longer supported.\nYou will need to get an updated version from the TC provider.\n");
                                printf("You should delete the old file: %s\n",filenam);
                                exit(1);
                                return; // no-op
                        default:
                                klseek(fp,0L,SEEK_SET);
                                break;
                }
//              if (lMagic == COMPMAGIC)
//              {
//                      bCompile=0;
//              }
//              else
//              {
//                      klseek(fp,0L,SEEK_SET);
//              }
                if(bCompile)
                {
#endif
//sprintf(g_szBuf,"CP:%s %d",__FILE__,__LINE__);
//AddLog(g_szBuf);
                printf("Compiling: '%s'.\n",filenam);

#ifdef EDUKE            
                AddSourceFile(filenam);
#endif
                
                fs = kfilelength(fp);

                last_used_text = textptr = (char *) mptr;
                last_used_size = fs;

//sprintf(g_szBuf,"CP:%s %d (%ld)",__FILE__,__LINE__,fs);
//AddLog(g_szBuf);
                kread(fp,(char *)textptr,fs);
#ifdef EDUKE
                }
#endif
//sprintf(g_szBuf,"CP:%s %d",__FILE__,__LINE__);
//AddLog(g_szBuf);
                kclose(fp);
//sprintf(g_szBuf,"CP:%s %d",__FILE__,__LINE__);
//AddLog(g_szBuf);
        }
#ifdef EDUKE
        if(bCompile)
        {
#endif
//sprintf(g_szBuf,"CP:%s %d",__FILE__,__LINE__);
//AddLog(g_szBuf);
        textptr[fs - 2] = 0;

        clearbuf(actorscrptr,MAXSPRITES,0L);
        clearbufbyte(actortype,MAXSPRITES,0L);

        labelcnt = 0;
        scriptptr = script+1;
        warning = 0;
        error = 0;
        line_number = 1;
        total_lines = 0;

//sprintf(g_szBuf,"CP:%s %d",__FILE__,__LINE__);
//AddLog(g_szBuf);
        passone(); //Tokenize
        *script = (long) scriptptr;
//sprintf(g_szBuf,"CP:%s %d",__FILE__,__LINE__);
//AddLog(g_szBuf);

        if(warning|error)
                printf("Found %ld warning(s), %ld error(s).\n",warning,error);

        if( error == 0 && warning != 0)
        {
#ifndef EDUKE
                // no internal defaults for EDUKE...
                if( groupfile != -1 && loadfromgrouponly == 0 )
                {
                        printf("\nWarnings found in %s file.  You should backup the original copies before\n",filenam);
                        puts("before attempting to modify them.  Do you want to use the");
                        puts("INTERNAL DEFAULTS (y/N)?");

                        KB_FlushKeyboardQueue();
                        while( KB_KeyWaiting() );
                        i = KB_Getch();
                        if(i == 'y' || i == 'Y' )
                        {
                                loadfromgrouponly = 1;
                                puts(" Yes");
                                return;
                        }
                }
#endif
        }

        if(error)
        {
                if( loadfromgrouponly )
                {
                        ShutDown();
                        sprintf(buf,"\nError in %s.",filenam);
                        gameexit(buf);
                }
                else
                {
#ifndef EDUKE
// no internal defaults for EDuke..
                        if( groupfile != -1 && loadfromgrouponly == 0 )
                        {
                                printf("\nErrors found in %s file.      You should backup the original copies\n",filenam);
                                puts("before attempting to modify them.  Do you want to use the");
                                puts("internal defaults (Y/N)?");

                                KB_FlushKeyboardQueue();
                                while( !KB_KeyWaiting() );

                                i = KB_Getch();
                                if( i == 'y' || i == 'Y' )
                                {
                                        puts(" Yes");
                                        loadfromgrouponly = 1;
                                        return;
                                }
                                else
                                {
                                        ShutDown();
                                        gameexit("");
                                }
                        }
#endif
                }
        }
        else
        {
                total_lines += line_number;
#ifdef WW2
                printf("Code Size:%ld bytes. %ld labels. %d/%d Variables.\n",
                           (long)((scriptptr-script)<<2)-4,
                           labelcnt,
                           iGameVarCount,
                           MAXGAMEVARS
                          );
#else
                printf("Code Size:%ld bytes(%ld labels).\n",(long)((scriptptr-script)<<2)-4,labelcnt);
//sprintf(g_szBuf,"CP:%s %d",__FILE__,__LINE__);
//AddLog(g_szBuf);
#endif
        }
#ifdef EDUKE
        {
                FILE *fil;
                char *l_scriptptrs;
//sprintf(g_szBuf,"CP:%s %d",__FILE__,__LINE__);
//AddLog(g_szBuf);

                _splitpath(filenam,NULL,NULL,basename,NULL);
//printf("file name = '%s', base='%s'\n",filenam,basename);

                strcat(basename,".mhs");
                
//              strcpy(filenam,"Compiled.mhs");
                filenam=basename;
                printf("Saving Compiled CON Code into: %s\n",filenam);
                
//sprintf(g_szBuf,"CP:%s %d",__FILE__,__LINE__);
//AddLog(g_szBuf);
                
                if ((fil = fopen(filenam,"wb")) == 0) 
                {
                        return;
                }
//sprintf(g_szBuf,"file=%ld",fil);
//AddLog(g_szBuf);

//sprintf(g_szBuf,"CP:%s %d",__FILE__,__LINE__);
//AddLog(g_szBuf);
                
                lMagic=COMPMAGIC;
                fwrite(&lMagic,sizeof(long),1,fil);

                lMagic=mulscale(rand(), 32767, 15)*1024;
                fwrite(&lMagic,sizeof(long),1,fil);
        
//              CryptSetKey(lMagic,256);
                if(1)
                {
//sprintf(g_szBuf,"CP:%s %d",__FILE__,__LINE__);
//AddLog(g_szBuf);

                        l_scriptptrs=malloc(MAXSCRIPTSIZE);
//sprintf(g_szBuf,"CP:%s %d",__FILE__,__LINE__);
//AddLog(g_szBuf);

                        SaveConComp(fil,l_scriptptrs);
//sprintf(g_szBuf,"CP:%s %d",__FILE__,__LINE__);
//AddLog(g_szBuf);

                        SaveGameVars(fil);
                        free(l_scriptptrs);
                        fclose(fil);
                        
                }
                else
                {
                        free(l_scriptptrs);
                        fclose(fil);
                        unlink(filenam);
                        printf("Unable to save file because CD not found.\n");
                }
                

//sprintf(g_szBuf,"CP:%s %d",__FILE__,__LINE__);
//AddLog(g_szBuf);
                ShutDown();
                exit(1);
//              gameexit("\nCode Compiled");
        }
        }
        else
        {
                long fil;
                char *l_scriptptrs;
                
                printf("Loading pre-compiled code from %s\n",filenam);
                if ((fil = kopen4load(filenam,0)) == -1)
                {
                        return;
                }
                kread(fil,&lMagic,sizeof(long));        // get magic
                switch(lMagic)
                {
                        case COMPMAGIC:
                                break;
                        case 1234:
                                printf("Old Compiled format is no longer supported.\n You will need to get updated files from the TC provider\n");
                                // fall through
                        default:
                        kclose(fil);
                        ShutDown();
                        printf("ERROR: Compiled file format not supported.  File may be corrupted.\n");
                        exit(1);
                }
                        
                
                kread(fil,&lMagic,sizeof(long));        // get crypt Key
//              CryptSetKey(lMagic,256);

                l_scriptptrs=(char *)kmalloc(MAXSCRIPTSIZE);
//sprintf(g_szBuf,"CP:%s %d",__FILE__,__LINE__);
//AddLog(g_szBuf);
                LoadCompCode(fil,l_scriptptrs);
//sprintf(g_szBuf,"CP:%s %d",__FILE__,__LINE__);
//AddLog(g_szBuf);
                
                ReadGameVars(fil);
//sprintf(g_szBuf,"CP:%s %d",__FILE__,__LINE__);
//AddLog(g_szBuf);
                
                kfree(l_scriptptrs);
                kclose(fil);
                if(g_szCompCreator[0]!=0)
                {
                        sprintf(g_szBuf,"Creator: %s\n",g_szCompCreator);
                        printf(g_szBuf);
                }
                if(g_szCompCopyright[0]!=0)
                {
                        sprintf(g_szBuf,"Copyright: %s\n",g_szCompCopyright);
                        printf(g_szBuf);
                }
                printf("Done Loading\n");
        }
//sprintf(g_szBuf,"CP:%s %d",__FILE__,__LINE__);
//AddLog(g_szBuf);
#endif
        
}




void AddSourceFile(char *ach)
{
        if(g_numSourceFiles >= MAXSOURCEFILES)
        {
                printf(" * WARNING: including more than maximum source files\n");
                warning++;
                return;
        }
        if(g_numSourceFiles == 0 )
        {
                memset(g_achSourceFiles, 0, sizeof(g_achSourceFiles));
        }

        if( g_cmddebug&CMDDEBUG_COMPILE)
        {
                FILE *fpo;
                if ((fpo = fopen("comp.map","a")) != 0) 
                {
                        if(g_numSourceFiles > 0)
                        {
                                fprintf(fpo,"-------\nIncluding File: %s from %s, Line: %ld\n",
                                                ach,

                                                g_achSourceFiles[g_currentSourceFile],
                                                line_number);
                        }
                        else
                        {
                                fprintf(fpo,"Starting Compilation with File: %s \n",
                                                ach);
                        }
                        if((scriptptr-script)<MAXSCRIPTSIZE)
                        {
                                fprintf(fpo,"Compiled Offset: %0lX\n",scriptptr-script);
                        }
                        fclose(fpo);
                }
        }
        
        g_currentSourceFile=g_numSourceFiles;
        strcpy(g_achSourceFiles[g_currentSourceFile],ach);
        g_numSourceFiles++;
        return;
}
void PopSourceFile()
{
        if( g_cmddebug&CMDDEBUG_COMPILE)
        {
                FILE *fpo;
                if ((fpo = fopen("comp.map","a")) != 0) 
                {
/*                      
                        int i;
                        fprintf(fpo,"%ld source files.  Current = %ld\n",
                                        g_numSourceFiles,
                                        g_currentSourceFile);
                        for(i=0;i<g_numSourceFiles;i++)
                        {
                                fprintf(fpo,"  Source file %ld='%s'\n",i,g_achSourceFiles[i]);
                        }
*/
                        if(g_numSourceFiles >= 0)
                        {
                                fprintf(fpo,"-------\nReturn to File: %s, Line: %ld\n",
                                                g_achSourceFiles[g_currentSourceFile],
                                                line_number);
                        }
                        else
                        {
                                fprintf(fpo,"Invalid Source File parsing\n");
                        }
                        fprintf(fpo,"Compiled Offset: %0lX\n",scriptptr-script);
                        fclose(fpo);
                }
        }

        return;
}

void SaveConComp(FILE *fil, char *scriptptrs)
{
        long i;
        long j;
//      char scriptptrs[MAXSCRIPTSIZE];
//sprintf(g_szBuf,"CP:%s %d",__FILE__,__LINE__);
//AddLog(g_szBuf);
        CryptFWrite(&g_bEnhanced,sizeof(g_bEnhanced),1,fil);

        CryptFWrite(&g_szCompCreator,sizeof(g_szCompCreator),1,fil);
        CryptFWrite(&g_szCompCopyright,sizeof(g_szCompCopyright),1,fil);

        CryptFWrite(&g_lKey,sizeof(g_lKey),1,fil);

        CryptFWrite(&actortype[0],sizeof(char),MAXTILES,fil);
#ifdef EDUKE

//sprintf(g_szBuf,"CP:%s %d",__FILE__,__LINE__);
//AddLog(g_szBuf);

        CryptFWrite(fta_quotes,64,NUMOFFIRSTTIMEACTIVE,fil);
//sprintf(g_szBuf,"CP:%s %d",__FILE__,__LINE__);
//AddLog(g_szBuf);

        CryptFWrite(sounds,14,NUM_SOUNDS,fil);
        CryptFWrite(soundm,1,NUM_SOUNDS,fil);
        CryptFWrite(soundpr,1,NUM_SOUNDS,fil);
        CryptFWrite(soundps,sizeof(short),NUM_SOUNDS,fil);
        CryptFWrite(soundpe,sizeof(short),NUM_SOUNDS,fil);
        CryptFWrite(soundvo,sizeof(short),NUM_SOUNDS,fil);
        CryptFWrite(soundsiz,sizeof(long),NUM_SOUNDS,fil);
        CryptFWrite(SoundOwner,sizeof(SoundOwner),1,fil);
//sprintf(g_szBuf,"CP:%s %d",__FILE__,__LINE__);
//AddLog(g_szBuf);

        CryptFWrite(&impact_damage,sizeof(impact_damage),1,fil);

        CryptFWrite(&gc,sizeof(gc),1,fil);
        CryptFWrite(&neartaghitdist,sizeof(neartaghitdist),1,fil);
        CryptFWrite(&lockclock,sizeof(lockclock),1,fil);
        CryptFWrite(&max_player_health,sizeof(max_player_health),1,fil);
        CryptFWrite(&max_armour_amount,sizeof(max_armour_amount),1,fil);
        CryptFWrite(&max_ammo_amount,sizeof(max_ammo_amount),1,fil);
//sprintf(g_szBuf,"CP:%s %d",__FILE__,__LINE__);
//AddLog(g_szBuf);

        CryptFWrite(&betaname,sizeof(betaname),1,fil);
        CryptFWrite(&level_names,sizeof(level_names),1,fil);
        CryptFWrite(&level_file_names,sizeof(level_file_names),1,fil);
        CryptFWrite(&partime,sizeof(partime),1,fil);
        CryptFWrite(&designertime,sizeof(designertime),1,fil);
        CryptFWrite(&volume_names,sizeof(volume_names),1,fil);
        CryptFWrite(&skill_names,sizeof(skill_names),1,fil);
//sprintf(g_szBuf,"CP:%s %d",__FILE__,__LINE__);
//AddLog(g_szBuf);

        CryptFWrite(&respawnactortime,sizeof(respawnactortime),1,fil);
        CryptFWrite(&respawnitemtime,sizeof(respawnitemtime),1,fil);

        CryptFWrite(&music_fn,sizeof(music_fn),1,fil);
        CryptFWrite(&music_select,sizeof(music_select),1,fil);
        CryptFWrite(&env_music_fn,sizeof(env_music_fn),1,fil);

//sprintf(g_szBuf,"CP:%s %d",__FILE__,__LINE__);
//AddLog(g_szBuf);

        CryptFWrite(&camerashitable,sizeof(camerashitable),1,fil);
        CryptFWrite(&freezerhurtowner,sizeof(freezerhurtowner),1,fil);
        CryptFWrite(&lasermode,sizeof(lasermode),1,fil);
        CryptFWrite(&numfreezebounces,sizeof(numfreezebounces),1,fil);
        CryptFWrite(&rpgblastradius,sizeof(rpgblastradius),1,fil);
        CryptFWrite(&pipebombblastradius,sizeof(pipebombblastradius),1,fil);
        CryptFWrite(&tripbombblastradius,sizeof(tripbombblastradius),1,fil);
        CryptFWrite(&shrinkerblastradius,sizeof(shrinkerblastradius),1,fil);
        CryptFWrite(&morterblastradius,sizeof(morterblastradius),1,fil);
        CryptFWrite(&bouncemineblastradius,sizeof(bouncemineblastradius),1,fil);
        CryptFWrite(&seenineblastradius,sizeof(seenineblastradius),1,fil);
        CryptFWrite(&dukefriction,sizeof(dukefriction),1,fil);
//sprintf(g_szBuf,"CP:%s %d",__FILE__,__LINE__);
//AddLog(g_szBuf);
        
////    
        
        // normalize to offsets
        for (i=0;i<MAXGAMEEVENTS;i++)
                apScriptGameEvent[i]-=(long)&script[0];
        
         CryptFWrite(&apScriptGameEvent,1,sizeof(apScriptGameEvent),fil);

         // return back to pointers
        for (i=0;i<MAXGAMEEVENTS;i++)
                apScriptGameEvent[i]+=(long)&script[0];

         CryptFWrite(g_achSourceFiles,sizeof(g_achSourceFiles),1,fil);
         CryptFWrite(&g_numSourceFiles,sizeof(g_numSourceFiles),1,fil);
         
#endif   
     for(i=0;i<MAXSCRIPTSIZE;i++)
     {
          if( (long)script[i] >= (long)(&script[0]) && (long)script[i] < (long)(&script[MAXSCRIPTSIZE]) )
          {
                scriptptrs[i] = 1;
                j = (long)script[i] - (long)&script[0];
                script[i] = j;
          }
          else scriptptrs[i] = 0;
     }

     CryptFWrite(&scriptptrs[0],1,MAXSCRIPTSIZE,fil);
     CryptFWrite(&script[0],4,MAXSCRIPTSIZE,fil);

     for(i=0;i<MAXSCRIPTSIZE;i++)
        if( scriptptrs[i] )
     {
        j = script[i]+(long)&script[0];
        script[i] = j;
     }

     for(i=0;i<MAXTILES;i++)
         if(actorscrptr[i])
     {
        j = (long)actorscrptr[i]-(long)&script[0];
        actorscrptr[i] = (long *)j;
     }
     CryptFWrite(&actorscrptr[0],4,MAXTILES,fil);
     for(i=0;i<MAXTILES;i++)
         if(actorscrptr[i])
     {
         j = (long)actorscrptr[i]+(long)&script[0];
         actorscrptr[i] = (long *)j;
     }

     for(i=0;i<MAXSPRITES;i++)
     {
        scriptptrs[i] = 0;

        if(actorscrptr[PN] == 0) continue;

        j = (long)&script[0];

        if(T2 >= j && T2 < (long)(&script[MAXSCRIPTSIZE]) )
        {
            scriptptrs[i] |= 1;
            T2 -= j;
        }
        if(T5 >= j && T5 < (long)(&script[MAXSCRIPTSIZE]) )
        {
            scriptptrs[i] |= 2;
            T5 -= j;
        }
        if(T6 >= j && T6 < (long)(&script[MAXSCRIPTSIZE]) )
        {
            scriptptrs[i] |= 4;
            T6 -= j;
        }
    }

    CryptFWrite(&scriptptrs[0],1,MAXSPRITES,fil);
}

